/* FileView.c generated by valac 0.56.14, the Vala compiler
 * generated from FileView.vala, do not modify */

/*-
 * Copyright (c) 2017 - 2022 elementary LLC. (https://elementary.io),
 *               2013 Julien Spautz <spautz.julien@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Julien Spautz <spautz.julien@gmail.com>, Andrei-Costin Zisu <matzipan@gmail.com>
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "codecore.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <gee.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>

enum  {
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_0_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_IGNORE_NEXT_SELECT_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_ICON_NAME_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_TITLE_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTIVE_PROJECT_PATH_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_NUM_PROPERTIES
};
static GParamSpec* scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
enum  {
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_SELECT_SIGNAL,
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_NUM_SIGNALS
};
static guint scratch_folder_manager_file_view_signals[SCRATCH_FOLDER_MANAGER_FILE_VIEW_NUM_SIGNALS] = {0};

struct _ScratchFolderManagerFileViewPrivate {
	GSettings* settings;
	ScratchServicesGitManager* git_manager;
	GActionGroup* toplevel_action_group;
	gboolean _ignore_next_select;
	gchar* _icon_name;
	gchar* _title;
};

struct _Block7Data {
	int _ref_count_;
	ScratchFolderManagerFileView* self;
	ScratchFolderManagerProjectFolderItem* folder_root;
};

static gint ScratchFolderManagerFileView_private_offset;
static gpointer scratch_folder_manager_file_view_parent_class = NULL;
static CodePaneSwitcherIface * scratch_folder_manager_file_view_code_pane_switcher_parent_iface = NULL;

static void scratch_folder_manager_file_view_on_item_selected (ScratchFolderManagerFileView* self,
                                                        GraniteWidgetsSourceListItem* item);
static void scratch_folder_manager_file_view_add_folder (ScratchFolderManagerFileView* self,
                                                  ScratchFolderManagerFile* folder,
                                                  gboolean expand);
static gboolean scratch_folder_manager_file_view_is_open (ScratchFolderManagerFileView* self,
                                                   ScratchFolderManagerFile* folder);
static GraniteWidgetsSourceListItem* scratch_folder_manager_file_view_find_path (ScratchFolderManagerFileView* self,
                                                                          GraniteWidgetsSourceListExpandableItem* list,
                                                                          const gchar* path,
                                                                          gboolean expand);
static gint __lambda43_ (ScratchFolderManagerFileView* self,
                  ScratchFolderManagerProjectFolderItem* a,
                  ScratchFolderManagerProjectFolderItem* b);
static gint ___lambda43__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static void _scratch_folder_manager_file_view_on_item_selected_granite_widgets_source_list_item_selected (GraniteWidgetsSourceList* _sender,
                                                                                                   GraniteWidgetsSourceListItem* item,
                                                                                                   gpointer self);
static void scratch_folder_manager_file_view_rename_items_with_same_name (ScratchFolderManagerFileView* self,
                                                                   ScratchFolderManagerItem* item);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda41_ (Block7Data* _data7_);
static void scratch_folder_manager_file_view_write_settings (ScratchFolderManagerFileView* self);
static void ___lambda41__scratch_folder_manager_project_folder_item_closed (ScratchFolderManagerProjectFolderItem* _sender,
                                                                     gpointer self);
static void __lambda42_ (Block7Data* _data7_);
static void ___lambda42__scratch_folder_manager_project_folder_item_close_all_except (ScratchFolderManagerProjectFolderItem* _sender,
                                                                               gpointer self);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static GObject * scratch_folder_manager_file_view_constructor (GType type,
                                                        guint n_construct_properties,
                                                        GObjectConstructParam * construct_properties);
static void _scratch_folder_manager_file_view___lambda49_ (ScratchFolderManagerFileView* self);
static void __scratch_folder_manager_file_view___lambda49__gtk_widget_realize (GtkWidget* _sender,
                                                                        gpointer self);
static void scratch_folder_manager_file_view_finalize (GObject * obj);
static GType scratch_folder_manager_file_view_get_type_once (void);
static void _vala_scratch_folder_manager_file_view_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec);
static void _vala_scratch_folder_manager_file_view_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
scratch_folder_manager_file_view_get_instance_private (ScratchFolderManagerFileView* self)
{
	return G_STRUCT_MEMBER_P (self, ScratchFolderManagerFileView_private_offset);
}

static void
scratch_folder_manager_file_view_on_item_selected (ScratchFolderManagerFileView* self,
                                                   GraniteWidgetsSourceListItem* item)
{
	gboolean _tmp0_;
#line 56 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/FolderManager/FileView.vala"
	_tmp0_ = self->priv->_ignore_next_select;
#line 59 "../src/FolderManager/FileView.vala"
	if (_tmp0_) {
#line 60 "../src/FolderManager/FileView.vala"
		scratch_folder_manager_file_view_set_ignore_next_select (self, FALSE);
#line 61 "../src/FolderManager/FileView.vala"
		return;
#line 161 "FileView.c"
	}
#line 64 "../src/FolderManager/FileView.vala"
	if (SCRATCH_FOLDER_MANAGER_IS_FILE_ITEM (item)) {
#line 165 "FileView.c"
		ScratchFolderManagerFile* _tmp1_;
		ScratchFolderManagerFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 65 "../src/FolderManager/FileView.vala"
		_tmp1_ = scratch_folder_manager_item_get_file ((ScratchFolderManagerItem*) G_TYPE_CHECK_INSTANCE_CAST (item, SCRATCH_FOLDER_MANAGER_TYPE_FILE_ITEM, ScratchFolderManagerFileItem));
#line 65 "../src/FolderManager/FileView.vala"
		_tmp2_ = _tmp1_;
#line 65 "../src/FolderManager/FileView.vala"
		_tmp3_ = scratch_folder_manager_file_get_path (_tmp2_);
#line 65 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 65 "../src/FolderManager/FileView.vala"
		_tmp5_ = _tmp4_;
#line 65 "../src/FolderManager/FileView.vala"
		g_signal_emit (self, scratch_folder_manager_file_view_signals[SCRATCH_FOLDER_MANAGER_FILE_VIEW_SELECT_SIGNAL], 0, _tmp5_);
#line 65 "../src/FolderManager/FileView.vala"
		_g_free0 (_tmp5_);
#line 185 "FileView.c"
	}
}

void
scratch_folder_manager_file_view_restore_saved_state (ScratchFolderManagerFileView* self)
{
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
#line 69 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/FolderManager/FileView.vala"
	_tmp0_ = self->priv->settings;
#line 70 "../src/FolderManager/FileView.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "opened-folders");
#line 201 "FileView.c"
	{
		gchar** path_collection = NULL;
		gint path_collection_length1 = 0;
		gint _path_collection_size_ = 0;
		gint path_it = 0;
#line 70 "../src/FolderManager/FileView.vala"
		path_collection = _tmp2_;
#line 70 "../src/FolderManager/FileView.vala"
		path_collection_length1 = _vala_array_length (_tmp1_);
#line 70 "../src/FolderManager/FileView.vala"
		for (path_it = 0; path_it < path_collection_length1; path_it = path_it + 1) {
#line 213 "FileView.c"
			const gchar* path = NULL;
#line 70 "../src/FolderManager/FileView.vala"
			path = path_collection[path_it];
#line 217 "FileView.c"
			{
				const gchar* _tmp3_;
				ScratchFolderManagerFile* _tmp4_;
				ScratchFolderManagerFile* _tmp5_;
#line 71 "../src/FolderManager/FileView.vala"
				_tmp3_ = path;
#line 71 "../src/FolderManager/FileView.vala"
				_tmp4_ = scratch_folder_manager_file_new (_tmp3_);
#line 71 "../src/FolderManager/FileView.vala"
				_tmp5_ = _tmp4_;
#line 71 "../src/FolderManager/FileView.vala"
				scratch_folder_manager_file_view_add_folder (self, _tmp5_, FALSE);
#line 71 "../src/FolderManager/FileView.vala"
				_g_object_unref0 (_tmp5_);
#line 232 "FileView.c"
			}
		}
#line 70 "../src/FolderManager/FileView.vala"
		path_collection = (_vala_array_free (path_collection, path_collection_length1, (GDestroyNotify) g_free), NULL);
#line 237 "FileView.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 77 "../src/FolderManager/FileView.vala"
	return self ? g_object_ref (self) : NULL;
#line 246 "FileView.c"
}

void
scratch_folder_manager_file_view_open_folder (ScratchFolderManagerFileView* self,
                                              ScratchFolderManagerFile* folder)
{
#line 75 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/FolderManager/FileView.vala"
	g_return_if_fail (folder != NULL);
#line 76 "../src/FolderManager/FileView.vala"
	if (scratch_folder_manager_file_view_is_open (self, folder)) {
#line 259 "FileView.c"
		GraniteWidgetsSourceListItem* existing = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GraniteWidgetsSourceListItem* _tmp5_;
		GraniteWidgetsSourceListItem* _tmp6_;
		GraniteWidgetsSourceListItem* _tmp7_;
		GraniteWidgetsSourceListItem* _tmp8_;
#line 77 "../src/FolderManager/FileView.vala"
		_tmp0_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 77 "../src/FolderManager/FileView.vala"
		_tmp1_ = _tmp0_;
#line 77 "../src/FolderManager/FileView.vala"
		_tmp2_ = scratch_folder_manager_file_get_path (folder);
#line 77 "../src/FolderManager/FileView.vala"
		_tmp3_ = _tmp2_;
#line 77 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 77 "../src/FolderManager/FileView.vala"
		_tmp5_ = scratch_folder_manager_file_view_find_path (self, _tmp1_, _tmp4_, FALSE);
#line 77 "../src/FolderManager/FileView.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 77 "../src/FolderManager/FileView.vala"
		_tmp7_ = _tmp6_;
#line 77 "../src/FolderManager/FileView.vala"
		_g_free0 (_tmp4_);
#line 77 "../src/FolderManager/FileView.vala"
		existing = _tmp7_;
#line 78 "../src/FolderManager/FileView.vala"
		_tmp8_ = existing;
#line 78 "../src/FolderManager/FileView.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM)) {
#line 294 "FileView.c"
			GraniteWidgetsSourceListItem* _tmp9_;
#line 79 "../src/FolderManager/FileView.vala"
			_tmp9_ = existing;
#line 79 "../src/FolderManager/FileView.vala"
			granite_widgets_source_list_expandable_item_set_expanded (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem), TRUE);
#line 300 "FileView.c"
		}
#line 82 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (existing);
#line 82 "../src/FolderManager/FileView.vala"
		return;
#line 306 "FileView.c"
	}
#line 85 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_add_folder (self, folder, TRUE);
#line 310 "FileView.c"
}

void
scratch_folder_manager_file_view_collapse_all (ScratchFolderManagerFileView* self)
{
#line 88 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 318 "FileView.c"
	{
		GeeIterator* _child_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 89 "../src/FolderManager/FileView.vala"
		_tmp0_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 89 "../src/FolderManager/FileView.vala"
		_tmp1_ = _tmp0_;
#line 89 "../src/FolderManager/FileView.vala"
		_tmp2_ = granite_widgets_source_list_expandable_item_get_children (_tmp1_);
#line 89 "../src/FolderManager/FileView.vala"
		_tmp3_ = _tmp2_;
#line 89 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 89 "../src/FolderManager/FileView.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 89 "../src/FolderManager/FileView.vala"
		_tmp6_ = _tmp5_;
#line 89 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp4_);
#line 89 "../src/FolderManager/FileView.vala"
		_child_it = _tmp6_;
#line 89 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 348 "FileView.c"
			GeeIterator* _tmp7_;
			GraniteWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GraniteWidgetsSourceListItem* _tmp10_;
#line 89 "../src/FolderManager/FileView.vala"
			_tmp7_ = _child_it;
#line 89 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 89 "../src/FolderManager/FileView.vala"
				break;
#line 360 "FileView.c"
			}
#line 89 "../src/FolderManager/FileView.vala"
			_tmp8_ = _child_it;
#line 89 "../src/FolderManager/FileView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 89 "../src/FolderManager/FileView.vala"
			child = (GraniteWidgetsSourceListItem*) _tmp9_;
#line 90 "../src/FolderManager/FileView.vala"
			_tmp10_ = child;
#line 90 "../src/FolderManager/FileView.vala"
			granite_widgets_source_list_expandable_item_collapse_all ((GraniteWidgetsSourceListExpandableItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, SCRATCH_FOLDER_MANAGER_TYPE_PROJECT_FOLDER_ITEM, ScratchFolderManagerProjectFolderItem), TRUE, TRUE);
#line 89 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 374 "FileView.c"
		}
#line 89 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 378 "FileView.c"
	}
}

static gint
__lambda43_ (ScratchFolderManagerFileView* self,
             ScratchFolderManagerProjectFolderItem* a,
             ScratchFolderManagerProjectFolderItem* b)
{
	gint _tmp0_ = 0;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean _tmp9_;
	gint result;
#line 102 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 102 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 103 "../src/FolderManager/FileView.vala"
	_tmp1_ = granite_widgets_source_list_item_get_name ((GraniteWidgetsSourceListItem*) a);
#line 103 "../src/FolderManager/FileView.vala"
	_tmp2_ = _tmp1_;
#line 103 "../src/FolderManager/FileView.vala"
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 103 "../src/FolderManager/FileView.vala"
	_tmp4_ = _tmp3_;
#line 103 "../src/FolderManager/FileView.vala"
	_tmp5_ = granite_widgets_source_list_item_get_name ((GraniteWidgetsSourceListItem*) b);
#line 103 "../src/FolderManager/FileView.vala"
	_tmp6_ = _tmp5_;
#line 103 "../src/FolderManager/FileView.vala"
	_tmp7_ = g_utf8_strdown (_tmp6_, (gssize) -1);
#line 103 "../src/FolderManager/FileView.vala"
	_tmp8_ = _tmp7_;
#line 103 "../src/FolderManager/FileView.vala"
	_tmp9_ = g_strcmp0 (_tmp4_, _tmp8_) > 0;
#line 103 "../src/FolderManager/FileView.vala"
	_g_free0 (_tmp8_);
#line 103 "../src/FolderManager/FileView.vala"
	_g_free0 (_tmp4_);
#line 103 "../src/FolderManager/FileView.vala"
	if (_tmp9_) {
#line 103 "../src/FolderManager/FileView.vala"
		_tmp0_ = 0;
#line 428 "FileView.c"
	} else {
#line 103 "../src/FolderManager/FileView.vala"
		_tmp0_ = -1;
#line 432 "FileView.c"
	}
#line 103 "../src/FolderManager/FileView.vala"
	result = _tmp0_;
#line 103 "../src/FolderManager/FileView.vala"
	return result;
#line 438 "FileView.c"
}

static gint
___lambda43__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda43_ ((ScratchFolderManagerFileView*) self, (ScratchFolderManagerProjectFolderItem*) a, (ScratchFolderManagerProjectFolderItem*) b);
#line 102 "../src/FolderManager/FileView.vala"
	return result;
#line 450 "FileView.c"
}

void
scratch_folder_manager_file_view_order_folders (ScratchFolderManagerFileView* self)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp16_;
#line 94 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/FolderManager/FileView.vala"
	_tmp0_ = gee_array_list_new (SCRATCH_FOLDER_MANAGER_TYPE_PROJECT_FOLDER_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 95 "../src/FolderManager/FileView.vala"
	list = _tmp0_;
#line 465 "FileView.c"
	{
		GeeIterator* _child_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GraniteWidgetsSourceListExpandableItem* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeIterator* _tmp6_;
		GeeIterator* _tmp7_;
#line 97 "../src/FolderManager/FileView.vala"
		_tmp1_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 97 "../src/FolderManager/FileView.vala"
		_tmp2_ = _tmp1_;
#line 97 "../src/FolderManager/FileView.vala"
		_tmp3_ = granite_widgets_source_list_expandable_item_get_children (_tmp2_);
#line 97 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 97 "../src/FolderManager/FileView.vala"
		_tmp5_ = _tmp4_;
#line 97 "../src/FolderManager/FileView.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 97 "../src/FolderManager/FileView.vala"
		_tmp7_ = _tmp6_;
#line 97 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp5_);
#line 97 "../src/FolderManager/FileView.vala"
		_child_it = _tmp7_;
#line 97 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 495 "FileView.c"
			GeeIterator* _tmp8_;
			GraniteWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			GraniteWidgetsSourceListExpandableItem* _tmp11_;
			GraniteWidgetsSourceListExpandableItem* _tmp12_;
			GraniteWidgetsSourceListItem* _tmp13_;
			GeeArrayList* _tmp14_;
			GraniteWidgetsSourceListItem* _tmp15_;
#line 97 "../src/FolderManager/FileView.vala"
			_tmp8_ = _child_it;
#line 97 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp8_)) {
#line 97 "../src/FolderManager/FileView.vala"
				break;
#line 511 "FileView.c"
			}
#line 97 "../src/FolderManager/FileView.vala"
			_tmp9_ = _child_it;
#line 97 "../src/FolderManager/FileView.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 97 "../src/FolderManager/FileView.vala"
			child = (GraniteWidgetsSourceListItem*) _tmp10_;
#line 98 "../src/FolderManager/FileView.vala"
			_tmp11_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 98 "../src/FolderManager/FileView.vala"
			_tmp12_ = _tmp11_;
#line 98 "../src/FolderManager/FileView.vala"
			_tmp13_ = child;
#line 98 "../src/FolderManager/FileView.vala"
			granite_widgets_source_list_expandable_item_remove (_tmp12_, (GraniteWidgetsSourceListItem*) (SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp13_) ? ((ScratchFolderManagerProjectFolderItem*) _tmp13_) : NULL));
#line 99 "../src/FolderManager/FileView.vala"
			_tmp14_ = list;
#line 99 "../src/FolderManager/FileView.vala"
			_tmp15_ = child;
#line 99 "../src/FolderManager/FileView.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp15_) ? ((ScratchFolderManagerProjectFolderItem*) _tmp15_) : NULL);
#line 97 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 535 "FileView.c"
		}
#line 97 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 539 "FileView.c"
	}
#line 102 "../src/FolderManager/FileView.vala"
	_tmp16_ = list;
#line 102 "../src/FolderManager/FileView.vala"
	gee_list_sort ((GeeList*) _tmp16_, ___lambda43__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 545 "FileView.c"
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp17_;
		gint _item_size = 0;
		GeeArrayList* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gint _item_index = 0;
#line 106 "../src/FolderManager/FileView.vala"
		_tmp17_ = list;
#line 106 "../src/FolderManager/FileView.vala"
		_item_list = _tmp17_;
#line 106 "../src/FolderManager/FileView.vala"
		_tmp18_ = _item_list;
#line 106 "../src/FolderManager/FileView.vala"
		_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 106 "../src/FolderManager/FileView.vala"
		_tmp20_ = _tmp19_;
#line 106 "../src/FolderManager/FileView.vala"
		_item_size = _tmp20_;
#line 106 "../src/FolderManager/FileView.vala"
		_item_index = -1;
#line 106 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 570 "FileView.c"
			gint _tmp21_;
			gint _tmp22_;
			ScratchFolderManagerProjectFolderItem* item = NULL;
			GeeArrayList* _tmp23_;
			gpointer _tmp24_;
			GraniteWidgetsSourceListExpandableItem* _tmp25_;
			GraniteWidgetsSourceListExpandableItem* _tmp26_;
			ScratchFolderManagerProjectFolderItem* _tmp27_;
#line 106 "../src/FolderManager/FileView.vala"
			_item_index = _item_index + 1;
#line 106 "../src/FolderManager/FileView.vala"
			_tmp21_ = _item_index;
#line 106 "../src/FolderManager/FileView.vala"
			_tmp22_ = _item_size;
#line 106 "../src/FolderManager/FileView.vala"
			if (!(_tmp21_ < _tmp22_)) {
#line 106 "../src/FolderManager/FileView.vala"
				break;
#line 589 "FileView.c"
			}
#line 106 "../src/FolderManager/FileView.vala"
			_tmp23_ = _item_list;
#line 106 "../src/FolderManager/FileView.vala"
			_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) _tmp23_, _item_index);
#line 106 "../src/FolderManager/FileView.vala"
			item = (ScratchFolderManagerProjectFolderItem*) _tmp24_;
#line 107 "../src/FolderManager/FileView.vala"
			_tmp25_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 107 "../src/FolderManager/FileView.vala"
			_tmp26_ = _tmp25_;
#line 107 "../src/FolderManager/FileView.vala"
			_tmp27_ = item;
#line 107 "../src/FolderManager/FileView.vala"
			granite_widgets_source_list_expandable_item_add (_tmp26_, (GraniteWidgetsSourceListItem*) _tmp27_);
#line 106 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (item);
#line 607 "FileView.c"
		}
	}
#line 94 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (list);
#line 612 "FileView.c"
}

static void
_scratch_folder_manager_file_view_on_item_selected_granite_widgets_source_list_item_selected (GraniteWidgetsSourceList* _sender,
                                                                                              GraniteWidgetsSourceListItem* item,
                                                                                              gpointer self)
{
#line 112 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_on_item_selected ((ScratchFolderManagerFileView*) self, item);
#line 622 "FileView.c"
}

void
scratch_folder_manager_file_view_select_path (ScratchFolderManagerFileView* self,
                                              const gchar* path)
{
	guint _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
#line 111 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/FolderManager/FileView.vala"
	g_return_if_fail (path != NULL);
#line 112 "../src/FolderManager/FileView.vala"
	g_signal_parse_name ("item-selected", GRANITE_WIDGETS_TYPE_SOURCE_LIST, &_tmp0_, NULL, FALSE);
#line 112 "../src/FolderManager/FileView.vala"
	g_signal_handlers_disconnect_matched ((GraniteWidgetsSourceList*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _scratch_folder_manager_file_view_on_item_selected_granite_widgets_source_list_item_selected, self);
#line 113 "../src/FolderManager/FileView.vala"
	_tmp1_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 113 "../src/FolderManager/FileView.vala"
	_tmp2_ = _tmp1_;
#line 113 "../src/FolderManager/FileView.vala"
	_tmp3_ = scratch_folder_manager_file_view_find_path (self, _tmp2_, path, FALSE);
#line 113 "../src/FolderManager/FileView.vala"
	granite_widgets_source_list_set_selected ((GraniteWidgetsSourceList*) self, _tmp3_);
#line 114 "../src/FolderManager/FileView.vala"
	g_signal_connect_object ((GraniteWidgetsSourceList*) self, "item-selected", (GCallback) _scratch_folder_manager_file_view_on_item_selected_granite_widgets_source_list_item_selected, self, 0);
#line 651 "FileView.c"
}

void
scratch_folder_manager_file_view_collapse_other_projects (ScratchFolderManagerFileView* self,
                                                          const gchar* keep_open_path)
{
	const gchar* path = NULL;
#line 117 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/FolderManager/FileView.vala"
	if (keep_open_path == NULL) {
#line 663 "FileView.c"
		ScratchServicesGitManager* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 120 "../src/FolderManager/FileView.vala"
		_tmp0_ = self->priv->git_manager;
#line 120 "../src/FolderManager/FileView.vala"
		_tmp1_ = scratch_services_git_manager_get_active_project_path (_tmp0_);
#line 120 "../src/FolderManager/FileView.vala"
		_tmp2_ = _tmp1_;
#line 120 "../src/FolderManager/FileView.vala"
		path = _tmp2_;
#line 675 "FileView.c"
	} else {
		ScratchServicesGitManager* _tmp3_;
		const gchar* _tmp4_;
#line 122 "../src/FolderManager/FileView.vala"
		path = keep_open_path;
#line 123 "../src/FolderManager/FileView.vala"
		_tmp3_ = self->priv->git_manager;
#line 123 "../src/FolderManager/FileView.vala"
		_tmp4_ = path;
#line 123 "../src/FolderManager/FileView.vala"
		scratch_services_git_manager_set_active_project_path (_tmp3_, _tmp4_);
#line 687 "FileView.c"
	}
	{
		GeeIterator* _child_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp5_;
		GraniteWidgetsSourceListExpandableItem* _tmp6_;
		GeeCollection* _tmp7_;
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
#line 126 "../src/FolderManager/FileView.vala"
		_tmp5_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 126 "../src/FolderManager/FileView.vala"
		_tmp6_ = _tmp5_;
#line 126 "../src/FolderManager/FileView.vala"
		_tmp7_ = granite_widgets_source_list_expandable_item_get_children (_tmp6_);
#line 126 "../src/FolderManager/FileView.vala"
		_tmp8_ = _tmp7_;
#line 126 "../src/FolderManager/FileView.vala"
		_tmp9_ = _tmp8_;
#line 126 "../src/FolderManager/FileView.vala"
		_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 126 "../src/FolderManager/FileView.vala"
		_tmp11_ = _tmp10_;
#line 126 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp9_);
#line 126 "../src/FolderManager/FileView.vala"
		_child_it = _tmp11_;
#line 126 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 718 "FileView.c"
			GeeIterator* _tmp12_;
			GraniteWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
			ScratchFolderManagerProjectFolderItem* project_folder = NULL;
			GraniteWidgetsSourceListItem* _tmp15_;
			ScratchFolderManagerProjectFolderItem* _tmp16_;
			ScratchFolderManagerProjectFolderItem* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			const gchar* _tmp21_;
			gboolean _tmp22_;
#line 126 "../src/FolderManager/FileView.vala"
			_tmp12_ = _child_it;
#line 126 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp12_)) {
#line 126 "../src/FolderManager/FileView.vala"
				break;
#line 738 "FileView.c"
			}
#line 126 "../src/FolderManager/FileView.vala"
			_tmp13_ = _child_it;
#line 126 "../src/FolderManager/FileView.vala"
			_tmp14_ = gee_iterator_get (_tmp13_);
#line 126 "../src/FolderManager/FileView.vala"
			child = (GraniteWidgetsSourceListItem*) _tmp14_;
#line 127 "../src/FolderManager/FileView.vala"
			_tmp15_ = child;
#line 127 "../src/FolderManager/FileView.vala"
			_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, SCRATCH_FOLDER_MANAGER_TYPE_PROJECT_FOLDER_ITEM, ScratchFolderManagerProjectFolderItem));
#line 127 "../src/FolderManager/FileView.vala"
			project_folder = _tmp16_;
#line 128 "../src/FolderManager/FileView.vala"
			_tmp17_ = project_folder;
#line 128 "../src/FolderManager/FileView.vala"
			_tmp18_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp17_);
#line 128 "../src/FolderManager/FileView.vala"
			_tmp19_ = _tmp18_;
#line 128 "../src/FolderManager/FileView.vala"
			_tmp20_ = _tmp19_;
#line 128 "../src/FolderManager/FileView.vala"
			_tmp21_ = path;
#line 128 "../src/FolderManager/FileView.vala"
			_tmp22_ = g_strcmp0 (_tmp20_, _tmp21_) != 0;
#line 128 "../src/FolderManager/FileView.vala"
			_g_free0 (_tmp20_);
#line 128 "../src/FolderManager/FileView.vala"
			if (_tmp22_) {
#line 768 "FileView.c"
				ScratchFolderManagerProjectFolderItem* _tmp23_;
				GActionGroup* _tmp24_;
				ScratchFolderManagerProjectFolderItem* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				GVariant* _tmp29_;
				GVariant* _tmp30_;
#line 129 "../src/FolderManager/FileView.vala"
				_tmp23_ = project_folder;
#line 129 "../src/FolderManager/FileView.vala"
				granite_widgets_source_list_expandable_item_set_expanded ((GraniteWidgetsSourceListExpandableItem*) _tmp23_, FALSE);
#line 130 "../src/FolderManager/FileView.vala"
				_tmp24_ = self->priv->toplevel_action_group;
#line 130 "../src/FolderManager/FileView.vala"
				_tmp25_ = project_folder;
#line 130 "../src/FolderManager/FileView.vala"
				_tmp26_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp25_);
#line 130 "../src/FolderManager/FileView.vala"
				_tmp27_ = _tmp26_;
#line 130 "../src/FolderManager/FileView.vala"
				_tmp28_ = _tmp27_;
#line 130 "../src/FolderManager/FileView.vala"
				_tmp29_ = g_variant_new_string (_tmp28_);
#line 130 "../src/FolderManager/FileView.vala"
				g_variant_ref_sink (_tmp29_);
#line 130 "../src/FolderManager/FileView.vala"
				_tmp30_ = _tmp29_;
#line 130 "../src/FolderManager/FileView.vala"
				g_action_group_activate_action (_tmp24_, SCRATCH_MAIN_WINDOW_ACTION_HIDE_PROJECT_DOCS, _tmp30_);
#line 130 "../src/FolderManager/FileView.vala"
				_g_variant_unref0 (_tmp30_);
#line 130 "../src/FolderManager/FileView.vala"
				_g_free0 (_tmp28_);
#line 803 "FileView.c"
			} else {
				ScratchFolderManagerProjectFolderItem* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				const gchar* _tmp35_;
				gboolean _tmp36_;
#line 131 "../src/FolderManager/FileView.vala"
				_tmp31_ = project_folder;
#line 131 "../src/FolderManager/FileView.vala"
				_tmp32_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp31_);
#line 131 "../src/FolderManager/FileView.vala"
				_tmp33_ = _tmp32_;
#line 131 "../src/FolderManager/FileView.vala"
				_tmp34_ = _tmp33_;
#line 131 "../src/FolderManager/FileView.vala"
				_tmp35_ = path;
#line 131 "../src/FolderManager/FileView.vala"
				_tmp36_ = g_strcmp0 (_tmp34_, _tmp35_) == 0;
#line 131 "../src/FolderManager/FileView.vala"
				_g_free0 (_tmp34_);
#line 131 "../src/FolderManager/FileView.vala"
				if (_tmp36_) {
#line 827 "FileView.c"
					ScratchFolderManagerProjectFolderItem* _tmp37_;
					GActionGroup* _tmp38_;
					ScratchFolderManagerProjectFolderItem* _tmp39_;
					gchar* _tmp40_;
					gchar* _tmp41_;
					gchar* _tmp42_;
					GVariant* _tmp43_;
					GVariant* _tmp44_;
#line 132 "../src/FolderManager/FileView.vala"
					_tmp37_ = project_folder;
#line 132 "../src/FolderManager/FileView.vala"
					granite_widgets_source_list_expandable_item_set_expanded ((GraniteWidgetsSourceListExpandableItem*) _tmp37_, TRUE);
#line 133 "../src/FolderManager/FileView.vala"
					_tmp38_ = self->priv->toplevel_action_group;
#line 133 "../src/FolderManager/FileView.vala"
					_tmp39_ = project_folder;
#line 133 "../src/FolderManager/FileView.vala"
					_tmp40_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp39_);
#line 133 "../src/FolderManager/FileView.vala"
					_tmp41_ = _tmp40_;
#line 133 "../src/FolderManager/FileView.vala"
					_tmp42_ = _tmp41_;
#line 133 "../src/FolderManager/FileView.vala"
					_tmp43_ = g_variant_new_string (_tmp42_);
#line 133 "../src/FolderManager/FileView.vala"
					g_variant_ref_sink (_tmp43_);
#line 133 "../src/FolderManager/FileView.vala"
					_tmp44_ = _tmp43_;
#line 133 "../src/FolderManager/FileView.vala"
					g_action_group_activate_action (_tmp38_, SCRATCH_MAIN_WINDOW_ACTION_RESTORE_PROJECT_DOCS, _tmp44_);
#line 133 "../src/FolderManager/FileView.vala"
					_g_variant_unref0 (_tmp44_);
#line 133 "../src/FolderManager/FileView.vala"
					_g_free0 (_tmp42_);
#line 862 "FileView.c"
				}
			}
#line 126 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (project_folder);
#line 126 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 869 "FileView.c"
		}
#line 126 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 873 "FileView.c"
	}
}

static GraniteWidgetsSourceListItem*
scratch_folder_manager_file_view_find_path (ScratchFolderManagerFileView* self,
                                            GraniteWidgetsSourceListExpandableItem* list,
                                            const gchar* path,
                                            gboolean expand)
{
	GraniteWidgetsSourceListItem* result;
#line 138 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 138 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 138 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 890 "FileView.c"
	{
		GeeIterator* _item_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 141 "../src/FolderManager/FileView.vala"
		_tmp0_ = granite_widgets_source_list_expandable_item_get_children (list);
#line 141 "../src/FolderManager/FileView.vala"
		_tmp1_ = _tmp0_;
#line 141 "../src/FolderManager/FileView.vala"
		_tmp2_ = _tmp1_;
#line 141 "../src/FolderManager/FileView.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 141 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 141 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp2_);
#line 141 "../src/FolderManager/FileView.vala"
		_item_it = _tmp4_;
#line 141 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 914 "FileView.c"
			GeeIterator* _tmp5_;
			GraniteWidgetsSourceListItem* item = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GraniteWidgetsSourceListItem* _tmp8_;
#line 141 "../src/FolderManager/FileView.vala"
			_tmp5_ = _item_it;
#line 141 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 141 "../src/FolderManager/FileView.vala"
				break;
#line 926 "FileView.c"
			}
#line 141 "../src/FolderManager/FileView.vala"
			_tmp6_ = _item_it;
#line 141 "../src/FolderManager/FileView.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 141 "../src/FolderManager/FileView.vala"
			item = (GraniteWidgetsSourceListItem*) _tmp7_;
#line 142 "../src/FolderManager/FileView.vala"
			_tmp8_ = item;
#line 142 "../src/FolderManager/FileView.vala"
			if (SCRATCH_FOLDER_MANAGER_IS_ITEM (_tmp8_)) {
#line 938 "FileView.c"
				ScratchFolderManagerItem* code_item = NULL;
				GraniteWidgetsSourceListItem* _tmp9_;
				ScratchFolderManagerItem* _tmp10_;
				ScratchFolderManagerItem* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				gboolean _tmp15_;
				GraniteWidgetsSourceListItem* _tmp17_;
#line 143 "../src/FolderManager/FileView.vala"
				_tmp9_ = item;
#line 143 "../src/FolderManager/FileView.vala"
				_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, SCRATCH_FOLDER_MANAGER_TYPE_ITEM, ScratchFolderManagerItem));
#line 143 "../src/FolderManager/FileView.vala"
				code_item = _tmp10_;
#line 144 "../src/FolderManager/FileView.vala"
				_tmp11_ = code_item;
#line 144 "../src/FolderManager/FileView.vala"
				_tmp12_ = scratch_folder_manager_item_get_path (_tmp11_);
#line 144 "../src/FolderManager/FileView.vala"
				_tmp13_ = _tmp12_;
#line 144 "../src/FolderManager/FileView.vala"
				_tmp14_ = _tmp13_;
#line 144 "../src/FolderManager/FileView.vala"
				_tmp15_ = g_strcmp0 (_tmp14_, path) == 0;
#line 144 "../src/FolderManager/FileView.vala"
				_g_free0 (_tmp14_);
#line 144 "../src/FolderManager/FileView.vala"
				if (_tmp15_) {
#line 968 "FileView.c"
					GraniteWidgetsSourceListItem* _tmp16_;
#line 145 "../src/FolderManager/FileView.vala"
					_tmp16_ = item;
#line 145 "../src/FolderManager/FileView.vala"
					result = G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItem);
#line 145 "../src/FolderManager/FileView.vala"
					_g_object_unref0 (code_item);
#line 145 "../src/FolderManager/FileView.vala"
					_g_object_unref0 (item);
#line 145 "../src/FolderManager/FileView.vala"
					_g_object_unref0 (_item_it);
#line 145 "../src/FolderManager/FileView.vala"
					return result;
#line 982 "FileView.c"
				}
#line 148 "../src/FolderManager/FileView.vala"
				_tmp17_ = item;
#line 148 "../src/FolderManager/FileView.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM)) {
#line 988 "FileView.c"
					GraniteWidgetsSourceListExpandableItem* expander = NULL;
					GraniteWidgetsSourceListItem* _tmp18_;
					GraniteWidgetsSourceListExpandableItem* _tmp19_;
					ScratchFolderManagerItem* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					gboolean _tmp24_;
					GraniteWidgetsSourceListExpandableItem* _tmp25_;
					gboolean _tmp26_;
					gboolean _tmp27_;
					GraniteWidgetsSourceListItem* recurse_item = NULL;
					GraniteWidgetsSourceListExpandableItem* _tmp29_;
					GraniteWidgetsSourceListItem* _tmp30_;
					GraniteWidgetsSourceListItem* _tmp31_;
#line 149 "../src/FolderManager/FileView.vala"
					_tmp18_ = item;
#line 149 "../src/FolderManager/FileView.vala"
					_tmp19_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp18_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp18_) : NULL);
#line 149 "../src/FolderManager/FileView.vala"
					expander = _tmp19_;
#line 150 "../src/FolderManager/FileView.vala"
					_tmp20_ = code_item;
#line 150 "../src/FolderManager/FileView.vala"
					_tmp21_ = scratch_folder_manager_item_get_path (_tmp20_);
#line 150 "../src/FolderManager/FileView.vala"
					_tmp22_ = _tmp21_;
#line 150 "../src/FolderManager/FileView.vala"
					_tmp23_ = _tmp22_;
#line 150 "../src/FolderManager/FileView.vala"
					_tmp24_ = !g_str_has_prefix (path, _tmp23_);
#line 150 "../src/FolderManager/FileView.vala"
					_g_free0 (_tmp23_);
#line 150 "../src/FolderManager/FileView.vala"
					if (_tmp24_) {
#line 151 "../src/FolderManager/FileView.vala"
						_g_object_unref0 (expander);
#line 151 "../src/FolderManager/FileView.vala"
						_g_object_unref0 (code_item);
#line 151 "../src/FolderManager/FileView.vala"
						_g_object_unref0 (item);
#line 151 "../src/FolderManager/FileView.vala"
						continue;
#line 1032 "FileView.c"
					}
#line 154 "../src/FolderManager/FileView.vala"
					_tmp25_ = expander;
#line 154 "../src/FolderManager/FileView.vala"
					_tmp26_ = granite_widgets_source_list_expandable_item_get_expanded (_tmp25_);
#line 154 "../src/FolderManager/FileView.vala"
					_tmp27_ = _tmp26_;
#line 154 "../src/FolderManager/FileView.vala"
					if (!_tmp27_) {
#line 155 "../src/FolderManager/FileView.vala"
						if (expand) {
#line 1044 "FileView.c"
							GraniteWidgetsSourceListExpandableItem* _tmp28_;
#line 156 "../src/FolderManager/FileView.vala"
							_tmp28_ = expander;
#line 156 "../src/FolderManager/FileView.vala"
							granite_widgets_source_list_expandable_item_set_expanded (_tmp28_, TRUE);
#line 1050 "FileView.c"
						} else {
#line 158 "../src/FolderManager/FileView.vala"
							_g_object_unref0 (expander);
#line 158 "../src/FolderManager/FileView.vala"
							_g_object_unref0 (code_item);
#line 158 "../src/FolderManager/FileView.vala"
							_g_object_unref0 (item);
#line 158 "../src/FolderManager/FileView.vala"
							continue;
#line 1060 "FileView.c"
						}
					}
#line 162 "../src/FolderManager/FileView.vala"
					_tmp29_ = expander;
#line 162 "../src/FolderManager/FileView.vala"
					_tmp30_ = scratch_folder_manager_file_view_find_path (self, _tmp29_, path, expand);
#line 162 "../src/FolderManager/FileView.vala"
					recurse_item = _tmp30_;
#line 163 "../src/FolderManager/FileView.vala"
					_tmp31_ = recurse_item;
#line 163 "../src/FolderManager/FileView.vala"
					if (_tmp31_ != NULL) {
#line 1073 "FileView.c"
						GraniteWidgetsSourceListItem* _tmp32_;
#line 164 "../src/FolderManager/FileView.vala"
						_tmp32_ = recurse_item;
#line 164 "../src/FolderManager/FileView.vala"
						result = _tmp32_;
#line 164 "../src/FolderManager/FileView.vala"
						_g_object_unref0 (expander);
#line 164 "../src/FolderManager/FileView.vala"
						_g_object_unref0 (code_item);
#line 164 "../src/FolderManager/FileView.vala"
						_g_object_unref0 (item);
#line 164 "../src/FolderManager/FileView.vala"
						_g_object_unref0 (_item_it);
#line 164 "../src/FolderManager/FileView.vala"
						return result;
#line 1089 "FileView.c"
					}
#line 148 "../src/FolderManager/FileView.vala"
					_g_object_unref0 (expander);
#line 1093 "FileView.c"
				}
#line 142 "../src/FolderManager/FileView.vala"
				_g_object_unref0 (code_item);
#line 1097 "FileView.c"
			}
#line 141 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (item);
#line 1101 "FileView.c"
		}
#line 141 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_item_it);
#line 1105 "FileView.c"
	}
#line 170 "../src/FolderManager/FileView.vala"
	result = NULL;
#line 170 "../src/FolderManager/FileView.vala"
	return result;
#line 1111 "FileView.c"
}

ScratchFolderManagerProjectFolderItem*
scratch_folder_manager_file_view_get_project_for_file (ScratchFolderManagerFileView* self,
                                                       GFile* file)
{
	ScratchFolderManagerProjectFolderItem* result;
#line 173 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 173 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 1123 "FileView.c"
	{
		GeeIterator* _item_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 174 "../src/FolderManager/FileView.vala"
		_tmp0_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 174 "../src/FolderManager/FileView.vala"
		_tmp1_ = _tmp0_;
#line 174 "../src/FolderManager/FileView.vala"
		_tmp2_ = granite_widgets_source_list_expandable_item_get_children (_tmp1_);
#line 174 "../src/FolderManager/FileView.vala"
		_tmp3_ = _tmp2_;
#line 174 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 174 "../src/FolderManager/FileView.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 174 "../src/FolderManager/FileView.vala"
		_tmp6_ = _tmp5_;
#line 174 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp4_);
#line 174 "../src/FolderManager/FileView.vala"
		_item_it = _tmp6_;
#line 174 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 1153 "FileView.c"
			GeeIterator* _tmp7_;
			GraniteWidgetsSourceListItem* item = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GraniteWidgetsSourceListItem* _tmp10_;
#line 174 "../src/FolderManager/FileView.vala"
			_tmp7_ = _item_it;
#line 174 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 174 "../src/FolderManager/FileView.vala"
				break;
#line 1165 "FileView.c"
			}
#line 174 "../src/FolderManager/FileView.vala"
			_tmp8_ = _item_it;
#line 174 "../src/FolderManager/FileView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 174 "../src/FolderManager/FileView.vala"
			item = (GraniteWidgetsSourceListItem*) _tmp9_;
#line 175 "../src/FolderManager/FileView.vala"
			_tmp10_ = item;
#line 175 "../src/FolderManager/FileView.vala"
			if (SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp10_)) {
#line 1177 "FileView.c"
				ScratchFolderManagerProjectFolderItem* folder = NULL;
				GraniteWidgetsSourceListItem* _tmp11_;
				ScratchFolderManagerProjectFolderItem* _tmp12_;
				ScratchFolderManagerProjectFolderItem* _tmp13_;
#line 176 "../src/FolderManager/FileView.vala"
				_tmp11_ = item;
#line 176 "../src/FolderManager/FileView.vala"
				_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, SCRATCH_FOLDER_MANAGER_TYPE_PROJECT_FOLDER_ITEM, ScratchFolderManagerProjectFolderItem));
#line 176 "../src/FolderManager/FileView.vala"
				folder = _tmp12_;
#line 177 "../src/FolderManager/FileView.vala"
				_tmp13_ = folder;
#line 177 "../src/FolderManager/FileView.vala"
				if (scratch_folder_manager_project_folder_item_contains_file (_tmp13_, file)) {
#line 178 "../src/FolderManager/FileView.vala"
					result = folder;
#line 178 "../src/FolderManager/FileView.vala"
					_g_object_unref0 (item);
#line 178 "../src/FolderManager/FileView.vala"
					_g_object_unref0 (_item_it);
#line 178 "../src/FolderManager/FileView.vala"
					return result;
#line 1200 "FileView.c"
				}
#line 175 "../src/FolderManager/FileView.vala"
				_g_object_unref0 (folder);
#line 1204 "FileView.c"
			}
#line 174 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (item);
#line 1208 "FileView.c"
		}
#line 174 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_item_it);
#line 1212 "FileView.c"
	}
#line 183 "../src/FolderManager/FileView.vala"
	result = NULL;
#line 183 "../src/FolderManager/FileView.vala"
	return result;
#line 1218 "FileView.c"
}

GraniteWidgetsSourceListItem*
scratch_folder_manager_file_view_expand_to_path (ScratchFolderManagerFileView* self,
                                                 const gchar* path)
{
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	GraniteWidgetsSourceListItem* result;
#line 186 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 186 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 187 "../src/FolderManager/FileView.vala"
	_tmp0_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 187 "../src/FolderManager/FileView.vala"
	_tmp1_ = _tmp0_;
#line 187 "../src/FolderManager/FileView.vala"
	_tmp2_ = scratch_folder_manager_file_view_find_path (self, _tmp1_, path, TRUE);
#line 187 "../src/FolderManager/FileView.vala"
	result = _tmp2_;
#line 187 "../src/FolderManager/FileView.vala"
	return result;
#line 1243 "FileView.c"
}

void
scratch_folder_manager_file_view_search_global (ScratchFolderManagerFileView* self,
                                                const gchar* path,
                                                const gchar* term)
{
	ScratchFolderManagerItem* item_for_path = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	ScratchFolderManagerItem* _tmp1_;
	ScratchFolderManagerItem* _tmp2_;
#line 191 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 191 "../src/FolderManager/FileView.vala"
	g_return_if_fail (path != NULL);
#line 192 "../src/FolderManager/FileView.vala"
	_tmp0_ = scratch_folder_manager_file_view_expand_to_path (self, path);
#line 192 "../src/FolderManager/FileView.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, SCRATCH_FOLDER_MANAGER_TYPE_ITEM, ScratchFolderManagerItem));
#line 192 "../src/FolderManager/FileView.vala"
	item_for_path = _tmp1_;
#line 193 "../src/FolderManager/FileView.vala"
	_tmp2_ = item_for_path;
#line 193 "../src/FolderManager/FileView.vala"
	if (_tmp2_ != NULL) {
#line 1269 "FileView.c"
		ScratchFolderManagerProjectFolderItem* search_root = NULL;
		ScratchFolderManagerItem* _tmp3_;
		ScratchFolderManagerProjectFolderItem* _tmp4_;
		ScratchFolderManagerProjectFolderItem* _tmp5_;
#line 194 "../src/FolderManager/FileView.vala"
		_tmp3_ = item_for_path;
#line 194 "../src/FolderManager/FileView.vala"
		_tmp4_ = scratch_folder_manager_item_get_root_folder (_tmp3_, NULL);
#line 194 "../src/FolderManager/FileView.vala"
		search_root = _tmp4_;
#line 195 "../src/FolderManager/FileView.vala"
		_tmp5_ = search_root;
#line 195 "../src/FolderManager/FileView.vala"
		if (SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp5_)) {
#line 1284 "FileView.c"
			ScratchFolderManagerProjectFolderItem* _tmp6_;
			ScratchFolderManagerProjectFolderItem* _tmp7_;
			ScratchFolderManagerFile* _tmp8_;
			ScratchFolderManagerFile* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
#line 196 "../src/FolderManager/FileView.vala"
			_tmp6_ = search_root;
#line 196 "../src/FolderManager/FileView.vala"
			_tmp7_ = search_root;
#line 196 "../src/FolderManager/FileView.vala"
			_tmp8_ = scratch_folder_manager_item_get_file ((ScratchFolderManagerItem*) _tmp7_);
#line 196 "../src/FolderManager/FileView.vala"
			_tmp9_ = _tmp8_;
#line 196 "../src/FolderManager/FileView.vala"
			_tmp10_ = scratch_folder_manager_file_get_file (_tmp9_);
#line 196 "../src/FolderManager/FileView.vala"
			_tmp11_ = _tmp10_;
#line 196 "../src/FolderManager/FileView.vala"
			scratch_folder_manager_project_folder_item_global_search (_tmp6_, _tmp11_, term);
#line 1305 "FileView.c"
		}
#line 193 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (search_root);
#line 1309 "FileView.c"
	}
#line 191 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (item_for_path);
#line 1313 "FileView.c"
}

void
scratch_folder_manager_file_view_clear_badges (ScratchFolderManagerFileView* self)
{
#line 201 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 1321 "FileView.c"
	{
		GeeIterator* _child_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 202 "../src/FolderManager/FileView.vala"
		_tmp0_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 202 "../src/FolderManager/FileView.vala"
		_tmp1_ = _tmp0_;
#line 202 "../src/FolderManager/FileView.vala"
		_tmp2_ = granite_widgets_source_list_expandable_item_get_children (_tmp1_);
#line 202 "../src/FolderManager/FileView.vala"
		_tmp3_ = _tmp2_;
#line 202 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 202 "../src/FolderManager/FileView.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 202 "../src/FolderManager/FileView.vala"
		_tmp6_ = _tmp5_;
#line 202 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp4_);
#line 202 "../src/FolderManager/FileView.vala"
		_child_it = _tmp6_;
#line 202 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 1351 "FileView.c"
			GeeIterator* _tmp7_;
			GraniteWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GraniteWidgetsSourceListItem* _tmp10_;
#line 202 "../src/FolderManager/FileView.vala"
			_tmp7_ = _child_it;
#line 202 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 202 "../src/FolderManager/FileView.vala"
				break;
#line 1363 "FileView.c"
			}
#line 202 "../src/FolderManager/FileView.vala"
			_tmp8_ = _child_it;
#line 202 "../src/FolderManager/FileView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 202 "../src/FolderManager/FileView.vala"
			child = (GraniteWidgetsSourceListItem*) _tmp9_;
#line 203 "../src/FolderManager/FileView.vala"
			_tmp10_ = child;
#line 203 "../src/FolderManager/FileView.vala"
			if (SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp10_)) {
#line 1375 "FileView.c"
				GraniteWidgetsSourceListItem* _tmp11_;
#line 204 "../src/FolderManager/FileView.vala"
				_tmp11_ = child;
#line 204 "../src/FolderManager/FileView.vala"
				scratch_folder_manager_folder_item_remove_all_badges (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, SCRATCH_FOLDER_MANAGER_TYPE_FOLDER_ITEM, ScratchFolderManagerFolderItem));
#line 1381 "FileView.c"
			}
#line 202 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 1385 "FileView.c"
		}
#line 202 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 1389 "FileView.c"
	}
}

void
scratch_folder_manager_file_view_new_branch (ScratchFolderManagerFileView* self,
                                             const gchar* active_project_path)
{
	ScratchFolderManagerProjectFolderItem* active_project = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	gboolean _tmp3_ = FALSE;
	ScratchFolderManagerProjectFolderItem* _tmp4_;
	gchar* branch_name = NULL;
	ScratchDialogsNewBranchDialog* dialog = NULL;
	ScratchFolderManagerProjectFolderItem* _tmp8_;
	ScratchDialogsNewBranchDialog* _tmp9_;
	ScratchDialogsNewBranchDialog* _tmp10_;
	ScratchDialogsNewBranchDialog* _tmp11_;
	ScratchDialogsNewBranchDialog* _tmp16_;
	const gchar* _tmp17_;
#line 209 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 209 "../src/FolderManager/FileView.vala"
	g_return_if_fail (active_project_path != NULL);
#line 210 "../src/FolderManager/FileView.vala"
	_tmp0_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 210 "../src/FolderManager/FileView.vala"
	_tmp1_ = _tmp0_;
#line 210 "../src/FolderManager/FileView.vala"
	_tmp2_ = scratch_folder_manager_file_view_find_path (self, _tmp1_, active_project_path, FALSE);
#line 210 "../src/FolderManager/FileView.vala"
	active_project = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, SCRATCH_FOLDER_MANAGER_TYPE_PROJECT_FOLDER_ITEM, ScratchFolderManagerProjectFolderItem);
#line 211 "../src/FolderManager/FileView.vala"
	_tmp4_ = active_project;
#line 211 "../src/FolderManager/FileView.vala"
	if (_tmp4_ == NULL) {
#line 211 "../src/FolderManager/FileView.vala"
		_tmp3_ = TRUE;
#line 1429 "FileView.c"
	} else {
		ScratchFolderManagerProjectFolderItem* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 211 "../src/FolderManager/FileView.vala"
		_tmp5_ = active_project;
#line 211 "../src/FolderManager/FileView.vala"
		_tmp6_ = scratch_folder_manager_project_folder_item_get_is_git_repo (_tmp5_);
#line 211 "../src/FolderManager/FileView.vala"
		_tmp7_ = _tmp6_;
#line 211 "../src/FolderManager/FileView.vala"
		_tmp3_ = !_tmp7_;
#line 1442 "FileView.c"
	}
#line 211 "../src/FolderManager/FileView.vala"
	if (_tmp3_) {
#line 212 "../src/FolderManager/FileView.vala"
		gdk_beep ();
#line 213 "../src/FolderManager/FileView.vala"
		return;
#line 1450 "FileView.c"
	}
#line 216 "../src/FolderManager/FileView.vala"
	branch_name = NULL;
#line 217 "../src/FolderManager/FileView.vala"
	_tmp8_ = active_project;
#line 217 "../src/FolderManager/FileView.vala"
	_tmp9_ = scratch_dialogs_new_branch_dialog_new (_tmp8_);
#line 217 "../src/FolderManager/FileView.vala"
	g_object_ref_sink (_tmp9_);
#line 217 "../src/FolderManager/FileView.vala"
	dialog = _tmp9_;
#line 218 "../src/FolderManager/FileView.vala"
	_tmp10_ = dialog;
#line 218 "../src/FolderManager/FileView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp10_);
#line 219 "../src/FolderManager/FileView.vala"
	_tmp11_ = dialog;
#line 219 "../src/FolderManager/FileView.vala"
	if (gtk_dialog_run ((GtkDialog*) _tmp11_) == ((gint) GTK_RESPONSE_APPLY)) {
#line 1470 "FileView.c"
		ScratchDialogsNewBranchDialog* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 220 "../src/FolderManager/FileView.vala"
		_tmp12_ = dialog;
#line 220 "../src/FolderManager/FileView.vala"
		_tmp13_ = scratch_dialogs_new_branch_dialog_get_new_branch_name (_tmp12_);
#line 220 "../src/FolderManager/FileView.vala"
		_tmp14_ = _tmp13_;
#line 220 "../src/FolderManager/FileView.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 220 "../src/FolderManager/FileView.vala"
		_g_free0 (branch_name);
#line 220 "../src/FolderManager/FileView.vala"
		branch_name = _tmp15_;
#line 1487 "FileView.c"
	}
#line 223 "../src/FolderManager/FileView.vala"
	_tmp16_ = dialog;
#line 223 "../src/FolderManager/FileView.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp16_);
#line 224 "../src/FolderManager/FileView.vala"
	_tmp17_ = branch_name;
#line 224 "../src/FolderManager/FileView.vala"
	if (_tmp17_ != NULL) {
#line 1497 "FileView.c"
		ScratchFolderManagerProjectFolderItem* _tmp18_;
		const gchar* _tmp19_;
#line 225 "../src/FolderManager/FileView.vala"
		_tmp18_ = active_project;
#line 225 "../src/FolderManager/FileView.vala"
		_tmp19_ = branch_name;
#line 225 "../src/FolderManager/FileView.vala"
		scratch_folder_manager_project_folder_item_new_branch (_tmp18_, _tmp19_);
#line 1506 "FileView.c"
	}
#line 209 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (dialog);
#line 209 "../src/FolderManager/FileView.vala"
	_g_free0 (branch_name);
#line 1512 "FileView.c"
}

static void
scratch_folder_manager_file_view_rename_items_with_same_name (ScratchFolderManagerFileView* self,
                                                              ScratchFolderManagerItem* item)
{
	gchar* item_name = NULL;
	ScratchFolderManagerFile* _tmp0_;
	ScratchFolderManagerFile* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp47_;
#line 230 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 230 "../src/FolderManager/FileView.vala"
	g_return_if_fail (item != NULL);
#line 231 "../src/FolderManager/FileView.vala"
	_tmp0_ = scratch_folder_manager_item_get_file (item);
#line 231 "../src/FolderManager/FileView.vala"
	_tmp1_ = _tmp0_;
#line 231 "../src/FolderManager/FileView.vala"
	_tmp2_ = scratch_folder_manager_file_get_name (_tmp1_);
#line 231 "../src/FolderManager/FileView.vala"
	_tmp3_ = _tmp2_;
#line 231 "../src/FolderManager/FileView.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 231 "../src/FolderManager/FileView.vala"
	item_name = _tmp4_;
#line 1542 "FileView.c"
	{
		GeeIterator* _child_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp5_;
		GraniteWidgetsSourceListExpandableItem* _tmp6_;
		GeeCollection* _tmp7_;
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
#line 232 "../src/FolderManager/FileView.vala"
		_tmp5_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 232 "../src/FolderManager/FileView.vala"
		_tmp6_ = _tmp5_;
#line 232 "../src/FolderManager/FileView.vala"
		_tmp7_ = granite_widgets_source_list_expandable_item_get_children (_tmp6_);
#line 232 "../src/FolderManager/FileView.vala"
		_tmp8_ = _tmp7_;
#line 232 "../src/FolderManager/FileView.vala"
		_tmp9_ = _tmp8_;
#line 232 "../src/FolderManager/FileView.vala"
		_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 232 "../src/FolderManager/FileView.vala"
		_tmp11_ = _tmp10_;
#line 232 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp9_);
#line 232 "../src/FolderManager/FileView.vala"
		_child_it = _tmp11_;
#line 232 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 1572 "FileView.c"
			GeeIterator* _tmp12_;
			GraniteWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
			gchar* new_other_item_name = NULL;
			gchar* new_item_name = NULL;
			ScratchFolderManagerProjectFolderItem* other_item = NULL;
			GraniteWidgetsSourceListItem* _tmp15_;
			ScratchFolderManagerProjectFolderItem* _tmp16_;
			ScratchFolderManagerFile* _tmp17_;
			ScratchFolderManagerFile* _tmp18_;
			GFile* _tmp19_;
			GFile* _tmp20_;
			ScratchFolderManagerProjectFolderItem* _tmp21_;
			ScratchFolderManagerFile* _tmp22_;
			ScratchFolderManagerFile* _tmp23_;
			GFile* _tmp24_;
			GFile* _tmp25_;
			gchar* _tmp26_ = NULL;
			gchar* _tmp27_ = NULL;
			gboolean _tmp28_;
#line 232 "../src/FolderManager/FileView.vala"
			_tmp12_ = _child_it;
#line 232 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp12_)) {
#line 232 "../src/FolderManager/FileView.vala"
				break;
#line 1600 "FileView.c"
			}
#line 232 "../src/FolderManager/FileView.vala"
			_tmp13_ = _child_it;
#line 232 "../src/FolderManager/FileView.vala"
			_tmp14_ = gee_iterator_get (_tmp13_);
#line 232 "../src/FolderManager/FileView.vala"
			child = (GraniteWidgetsSourceListItem*) _tmp14_;
#line 234 "../src/FolderManager/FileView.vala"
			_tmp15_ = child;
#line 234 "../src/FolderManager/FileView.vala"
			_tmp16_ = _g_object_ref0 (SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp15_) ? ((ScratchFolderManagerProjectFolderItem*) _tmp15_) : NULL);
#line 234 "../src/FolderManager/FileView.vala"
			other_item = _tmp16_;
#line 236 "../src/FolderManager/FileView.vala"
			_tmp17_ = scratch_folder_manager_item_get_file (item);
#line 236 "../src/FolderManager/FileView.vala"
			_tmp18_ = _tmp17_;
#line 236 "../src/FolderManager/FileView.vala"
			_tmp19_ = scratch_folder_manager_file_get_file (_tmp18_);
#line 236 "../src/FolderManager/FileView.vala"
			_tmp20_ = _tmp19_;
#line 236 "../src/FolderManager/FileView.vala"
			_tmp21_ = other_item;
#line 236 "../src/FolderManager/FileView.vala"
			_tmp22_ = scratch_folder_manager_item_get_file ((ScratchFolderManagerItem*) _tmp21_);
#line 236 "../src/FolderManager/FileView.vala"
			_tmp23_ = _tmp22_;
#line 236 "../src/FolderManager/FileView.vala"
			_tmp24_ = scratch_folder_manager_file_get_file (_tmp23_);
#line 236 "../src/FolderManager/FileView.vala"
			_tmp25_ = _tmp24_;
#line 236 "../src/FolderManager/FileView.vala"
			_tmp28_ = scratch_utils_find_unique_path (_tmp20_, _tmp25_, &_tmp26_, &_tmp27_);
#line 236 "../src/FolderManager/FileView.vala"
			_g_free0 (new_item_name);
#line 236 "../src/FolderManager/FileView.vala"
			new_item_name = _tmp26_;
#line 236 "../src/FolderManager/FileView.vala"
			_g_free0 (new_other_item_name);
#line 236 "../src/FolderManager/FileView.vala"
			new_other_item_name = _tmp27_;
#line 236 "../src/FolderManager/FileView.vala"
			if (_tmp28_) {
#line 1644 "FileView.c"
				const gchar* _tmp29_;
				gint _tmp30_;
				gint _tmp31_;
				const gchar* _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				ScratchFolderManagerProjectFolderItem* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				gint _tmp40_;
				gint _tmp41_;
				const gchar* _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
#line 237 "../src/FolderManager/FileView.vala"
				_tmp29_ = item_name;
#line 237 "../src/FolderManager/FileView.vala"
				_tmp30_ = strlen (_tmp29_);
#line 237 "../src/FolderManager/FileView.vala"
				_tmp31_ = _tmp30_;
#line 237 "../src/FolderManager/FileView.vala"
				_tmp32_ = new_item_name;
#line 237 "../src/FolderManager/FileView.vala"
				_tmp33_ = strlen (_tmp32_);
#line 237 "../src/FolderManager/FileView.vala"
				_tmp34_ = _tmp33_;
#line 237 "../src/FolderManager/FileView.vala"
				if (_tmp31_ < _tmp34_) {
#line 1673 "FileView.c"
					const gchar* _tmp35_;
					gchar* _tmp36_;
#line 238 "../src/FolderManager/FileView.vala"
					_tmp35_ = new_item_name;
#line 238 "../src/FolderManager/FileView.vala"
					_tmp36_ = g_strdup (_tmp35_);
#line 238 "../src/FolderManager/FileView.vala"
					_g_free0 (item_name);
#line 238 "../src/FolderManager/FileView.vala"
					item_name = _tmp36_;
#line 1684 "FileView.c"
				}
#line 241 "../src/FolderManager/FileView.vala"
				_tmp37_ = other_item;
#line 241 "../src/FolderManager/FileView.vala"
				_tmp38_ = granite_widgets_source_list_item_get_name ((GraniteWidgetsSourceListItem*) _tmp37_);
#line 241 "../src/FolderManager/FileView.vala"
				_tmp39_ = _tmp38_;
#line 241 "../src/FolderManager/FileView.vala"
				_tmp40_ = strlen (_tmp39_);
#line 241 "../src/FolderManager/FileView.vala"
				_tmp41_ = _tmp40_;
#line 241 "../src/FolderManager/FileView.vala"
				_tmp42_ = new_other_item_name;
#line 241 "../src/FolderManager/FileView.vala"
				_tmp43_ = strlen (_tmp42_);
#line 241 "../src/FolderManager/FileView.vala"
				_tmp44_ = _tmp43_;
#line 241 "../src/FolderManager/FileView.vala"
				if (_tmp41_ < _tmp44_) {
#line 1704 "FileView.c"
					ScratchFolderManagerProjectFolderItem* _tmp45_;
					const gchar* _tmp46_;
#line 242 "../src/FolderManager/FileView.vala"
					_tmp45_ = other_item;
#line 242 "../src/FolderManager/FileView.vala"
					_tmp46_ = new_other_item_name;
#line 242 "../src/FolderManager/FileView.vala"
					granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) _tmp45_, _tmp46_);
#line 1713 "FileView.c"
				}
			}
#line 232 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (other_item);
#line 232 "../src/FolderManager/FileView.vala"
			_g_free0 (new_item_name);
#line 232 "../src/FolderManager/FileView.vala"
			_g_free0 (new_other_item_name);
#line 232 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 1724 "FileView.c"
		}
#line 232 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 1728 "FileView.c"
	}
#line 247 "../src/FolderManager/FileView.vala"
	_tmp47_ = item_name;
#line 247 "../src/FolderManager/FileView.vala"
	granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) item, _tmp47_);
#line 230 "../src/FolderManager/FileView.vala"
	_g_free0 (item_name);
#line 1736 "FileView.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 250 "../src/FolderManager/FileView.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 250 "../src/FolderManager/FileView.vala"
	return _data7_;
#line 1746 "FileView.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 250 "../src/FolderManager/FileView.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 1756 "FileView.c"
		ScratchFolderManagerFileView* self;
#line 250 "../src/FolderManager/FileView.vala"
		self = _data7_->self;
#line 250 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_data7_->folder_root);
#line 250 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (self);
#line 250 "../src/FolderManager/FileView.vala"
		g_slice_free (Block7Data, _data7_);
#line 1766 "FileView.c"
	}
}

static void
__lambda41_ (Block7Data* _data7_)
{
	ScratchFolderManagerFileView* self;
	GActionGroup* _tmp0_;
	ScratchFolderManagerProjectFolderItem* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	GraniteWidgetsSourceListExpandableItem* _tmp7_;
	GraniteWidgetsSourceListExpandableItem* _tmp8_;
	ScratchFolderManagerProjectFolderItem* _tmp9_;
	ScratchServicesGitManager* _tmp31_;
	ScratchServicesGitManager* _tmp32_;
	ScratchFolderManagerProjectFolderItem* _tmp33_;
#line 264 "../src/FolderManager/FileView.vala"
	self = _data7_->self;
#line 265 "../src/FolderManager/FileView.vala"
	_tmp0_ = self->priv->toplevel_action_group;
#line 265 "../src/FolderManager/FileView.vala"
	_tmp1_ = _data7_->folder_root;
#line 265 "../src/FolderManager/FileView.vala"
	_tmp2_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp1_);
#line 265 "../src/FolderManager/FileView.vala"
	_tmp3_ = _tmp2_;
#line 265 "../src/FolderManager/FileView.vala"
	_tmp4_ = _tmp3_;
#line 265 "../src/FolderManager/FileView.vala"
	_tmp5_ = g_variant_new_string (_tmp4_);
#line 265 "../src/FolderManager/FileView.vala"
	g_variant_ref_sink (_tmp5_);
#line 265 "../src/FolderManager/FileView.vala"
	_tmp6_ = _tmp5_;
#line 265 "../src/FolderManager/FileView.vala"
	g_action_group_activate_action (_tmp0_, SCRATCH_MAIN_WINDOW_ACTION_CLOSE_PROJECT_DOCS, _tmp6_);
#line 265 "../src/FolderManager/FileView.vala"
	_g_variant_unref0 (_tmp6_);
#line 265 "../src/FolderManager/FileView.vala"
	_g_free0 (_tmp4_);
#line 266 "../src/FolderManager/FileView.vala"
	_tmp7_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 266 "../src/FolderManager/FileView.vala"
	_tmp8_ = _tmp7_;
#line 266 "../src/FolderManager/FileView.vala"
	_tmp9_ = _data7_->folder_root;
#line 266 "../src/FolderManager/FileView.vala"
	granite_widgets_source_list_expandable_item_remove (_tmp8_, (GraniteWidgetsSourceListItem*) _tmp9_);
#line 1819 "FileView.c"
	{
		GeeIterator* _child_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp10_;
		GraniteWidgetsSourceListExpandableItem* _tmp11_;
		GeeCollection* _tmp12_;
		GeeCollection* _tmp13_;
		GeeCollection* _tmp14_;
		GeeIterator* _tmp15_;
		GeeIterator* _tmp16_;
#line 267 "../src/FolderManager/FileView.vala"
		_tmp10_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 267 "../src/FolderManager/FileView.vala"
		_tmp11_ = _tmp10_;
#line 267 "../src/FolderManager/FileView.vala"
		_tmp12_ = granite_widgets_source_list_expandable_item_get_children (_tmp11_);
#line 267 "../src/FolderManager/FileView.vala"
		_tmp13_ = _tmp12_;
#line 267 "../src/FolderManager/FileView.vala"
		_tmp14_ = _tmp13_;
#line 267 "../src/FolderManager/FileView.vala"
		_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
#line 267 "../src/FolderManager/FileView.vala"
		_tmp16_ = _tmp15_;
#line 267 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp14_);
#line 267 "../src/FolderManager/FileView.vala"
		_child_it = _tmp16_;
#line 267 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 1849 "FileView.c"
			GeeIterator* _tmp17_;
			GraniteWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp18_;
			gpointer _tmp19_;
			ScratchFolderManagerProjectFolderItem* child_folder = NULL;
			GraniteWidgetsSourceListItem* _tmp20_;
			ScratchFolderManagerProjectFolderItem* _tmp21_;
			ScratchFolderManagerProjectFolderItem* _tmp22_;
			const gchar* _tmp23_;
			const gchar* _tmp24_;
			ScratchFolderManagerProjectFolderItem* _tmp25_;
			ScratchFolderManagerFile* _tmp26_;
			ScratchFolderManagerFile* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
#line 267 "../src/FolderManager/FileView.vala"
			_tmp17_ = _child_it;
#line 267 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp17_)) {
#line 267 "../src/FolderManager/FileView.vala"
				break;
#line 1871 "FileView.c"
			}
#line 267 "../src/FolderManager/FileView.vala"
			_tmp18_ = _child_it;
#line 267 "../src/FolderManager/FileView.vala"
			_tmp19_ = gee_iterator_get (_tmp18_);
#line 267 "../src/FolderManager/FileView.vala"
			child = (GraniteWidgetsSourceListItem*) _tmp19_;
#line 268 "../src/FolderManager/FileView.vala"
			_tmp20_ = child;
#line 268 "../src/FolderManager/FileView.vala"
			_tmp21_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, SCRATCH_FOLDER_MANAGER_TYPE_PROJECT_FOLDER_ITEM, ScratchFolderManagerProjectFolderItem));
#line 268 "../src/FolderManager/FileView.vala"
			child_folder = _tmp21_;
#line 269 "../src/FolderManager/FileView.vala"
			_tmp22_ = child_folder;
#line 269 "../src/FolderManager/FileView.vala"
			_tmp23_ = granite_widgets_source_list_item_get_name ((GraniteWidgetsSourceListItem*) _tmp22_);
#line 269 "../src/FolderManager/FileView.vala"
			_tmp24_ = _tmp23_;
#line 269 "../src/FolderManager/FileView.vala"
			_tmp25_ = child_folder;
#line 269 "../src/FolderManager/FileView.vala"
			_tmp26_ = scratch_folder_manager_item_get_file ((ScratchFolderManagerItem*) _tmp25_);
#line 269 "../src/FolderManager/FileView.vala"
			_tmp27_ = _tmp26_;
#line 269 "../src/FolderManager/FileView.vala"
			_tmp28_ = scratch_folder_manager_file_get_name (_tmp27_);
#line 269 "../src/FolderManager/FileView.vala"
			_tmp29_ = _tmp28_;
#line 269 "../src/FolderManager/FileView.vala"
			if (g_strcmp0 (_tmp24_, _tmp29_) != 0) {
#line 1903 "FileView.c"
				ScratchFolderManagerProjectFolderItem* _tmp30_;
#line 270 "../src/FolderManager/FileView.vala"
				_tmp30_ = child_folder;
#line 270 "../src/FolderManager/FileView.vala"
				scratch_folder_manager_file_view_rename_items_with_same_name (self, (ScratchFolderManagerItem*) _tmp30_);
#line 1909 "FileView.c"
			}
#line 267 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child_folder);
#line 267 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 1915 "FileView.c"
		}
#line 267 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 1919 "FileView.c"
	}
#line 273 "../src/FolderManager/FileView.vala"
	_tmp31_ = scratch_services_git_manager_get_instance ();
#line 273 "../src/FolderManager/FileView.vala"
	_tmp32_ = _tmp31_;
#line 273 "../src/FolderManager/FileView.vala"
	_tmp33_ = _data7_->folder_root;
#line 273 "../src/FolderManager/FileView.vala"
	scratch_services_git_manager_remove_project (_tmp32_, _tmp33_);
#line 273 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (_tmp32_);
#line 274 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_write_settings (self);
#line 1933 "FileView.c"
}

static void
___lambda41__scratch_folder_manager_project_folder_item_closed (ScratchFolderManagerProjectFolderItem* _sender,
                                                                gpointer self)
{
#line 264 "../src/FolderManager/FileView.vala"
	__lambda41_ (self);
#line 1942 "FileView.c"
}

static void
__lambda42_ (Block7Data* _data7_)
{
	ScratchFolderManagerFileView* self;
#line 277 "../src/FolderManager/FileView.vala"
	self = _data7_->self;
#line 1951 "FileView.c"
	{
		GeeIterator* _child_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 278 "../src/FolderManager/FileView.vala"
		_tmp0_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 278 "../src/FolderManager/FileView.vala"
		_tmp1_ = _tmp0_;
#line 278 "../src/FolderManager/FileView.vala"
		_tmp2_ = granite_widgets_source_list_expandable_item_get_children (_tmp1_);
#line 278 "../src/FolderManager/FileView.vala"
		_tmp3_ = _tmp2_;
#line 278 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 278 "../src/FolderManager/FileView.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 278 "../src/FolderManager/FileView.vala"
		_tmp6_ = _tmp5_;
#line 278 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp4_);
#line 278 "../src/FolderManager/FileView.vala"
		_child_it = _tmp6_;
#line 278 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 1981 "FileView.c"
			GeeIterator* _tmp7_;
			GraniteWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			ScratchFolderManagerProjectFolderItem* project_folder_item = NULL;
			GraniteWidgetsSourceListItem* _tmp10_;
			ScratchFolderManagerProjectFolderItem* _tmp11_;
			ScratchFolderManagerProjectFolderItem* _tmp12_;
			ScratchFolderManagerProjectFolderItem* _tmp13_;
#line 278 "../src/FolderManager/FileView.vala"
			_tmp7_ = _child_it;
#line 278 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 278 "../src/FolderManager/FileView.vala"
				break;
#line 1997 "FileView.c"
			}
#line 278 "../src/FolderManager/FileView.vala"
			_tmp8_ = _child_it;
#line 278 "../src/FolderManager/FileView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 278 "../src/FolderManager/FileView.vala"
			child = (GraniteWidgetsSourceListItem*) _tmp9_;
#line 279 "../src/FolderManager/FileView.vala"
			_tmp10_ = child;
#line 279 "../src/FolderManager/FileView.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, SCRATCH_FOLDER_MANAGER_TYPE_PROJECT_FOLDER_ITEM, ScratchFolderManagerProjectFolderItem));
#line 279 "../src/FolderManager/FileView.vala"
			project_folder_item = _tmp11_;
#line 280 "../src/FolderManager/FileView.vala"
			_tmp12_ = project_folder_item;
#line 280 "../src/FolderManager/FileView.vala"
			_tmp13_ = _data7_->folder_root;
#line 280 "../src/FolderManager/FileView.vala"
			if (_tmp12_ != _tmp13_) {
#line 2017 "FileView.c"
				GActionGroup* _tmp14_;
				ScratchFolderManagerProjectFolderItem* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				GVariant* _tmp19_;
				GVariant* _tmp20_;
				GraniteWidgetsSourceListExpandableItem* _tmp21_;
				GraniteWidgetsSourceListExpandableItem* _tmp22_;
				ScratchFolderManagerProjectFolderItem* _tmp23_;
				ScratchServicesGitManager* _tmp24_;
				ScratchServicesGitManager* _tmp25_;
				ScratchFolderManagerProjectFolderItem* _tmp26_;
#line 281 "../src/FolderManager/FileView.vala"
				_tmp14_ = self->priv->toplevel_action_group;
#line 281 "../src/FolderManager/FileView.vala"
				_tmp15_ = project_folder_item;
#line 281 "../src/FolderManager/FileView.vala"
				_tmp16_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp15_);
#line 281 "../src/FolderManager/FileView.vala"
				_tmp17_ = _tmp16_;
#line 281 "../src/FolderManager/FileView.vala"
				_tmp18_ = _tmp17_;
#line 281 "../src/FolderManager/FileView.vala"
				_tmp19_ = g_variant_new_string (_tmp18_);
#line 281 "../src/FolderManager/FileView.vala"
				g_variant_ref_sink (_tmp19_);
#line 281 "../src/FolderManager/FileView.vala"
				_tmp20_ = _tmp19_;
#line 281 "../src/FolderManager/FileView.vala"
				g_action_group_activate_action (_tmp14_, SCRATCH_MAIN_WINDOW_ACTION_CLOSE_PROJECT_DOCS, _tmp20_);
#line 281 "../src/FolderManager/FileView.vala"
				_g_variant_unref0 (_tmp20_);
#line 281 "../src/FolderManager/FileView.vala"
				_g_free0 (_tmp18_);
#line 282 "../src/FolderManager/FileView.vala"
				_tmp21_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 282 "../src/FolderManager/FileView.vala"
				_tmp22_ = _tmp21_;
#line 282 "../src/FolderManager/FileView.vala"
				_tmp23_ = project_folder_item;
#line 282 "../src/FolderManager/FileView.vala"
				granite_widgets_source_list_expandable_item_remove (_tmp22_, (GraniteWidgetsSourceListItem*) _tmp23_);
#line 283 "../src/FolderManager/FileView.vala"
				_tmp24_ = scratch_services_git_manager_get_instance ();
#line 283 "../src/FolderManager/FileView.vala"
				_tmp25_ = _tmp24_;
#line 283 "../src/FolderManager/FileView.vala"
				_tmp26_ = project_folder_item;
#line 283 "../src/FolderManager/FileView.vala"
				scratch_services_git_manager_remove_project (_tmp25_, _tmp26_);
#line 283 "../src/FolderManager/FileView.vala"
				_g_object_unref0 (_tmp25_);
#line 2071 "FileView.c"
			}
#line 278 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (project_folder_item);
#line 278 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 2077 "FileView.c"
		}
#line 278 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 2081 "FileView.c"
	}
#line 287 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_write_settings (self);
#line 2085 "FileView.c"
}

static void
___lambda42__scratch_folder_manager_project_folder_item_close_all_except (ScratchFolderManagerProjectFolderItem* _sender,
                                                                          gpointer self)
{
#line 277 "../src/FolderManager/FileView.vala"
	__lambda42_ (self);
#line 2094 "FileView.c"
}

static void
scratch_folder_manager_file_view_add_folder (ScratchFolderManagerFileView* self,
                                             ScratchFolderManagerFile* folder,
                                             gboolean expand)
{
	Block7Data* _data7_;
	ScratchFolderManagerProjectFolderItem* _tmp3_;
	GraniteWidgetsSourceListExpandableItem* _tmp4_;
	GraniteWidgetsSourceListExpandableItem* _tmp5_;
	ScratchFolderManagerProjectFolderItem* _tmp6_;
	ScratchFolderManagerProjectFolderItem* _tmp7_;
	ScratchFolderManagerProjectFolderItem* _tmp8_;
	ScratchFolderManagerProjectFolderItem* _tmp9_;
	ScratchFolderManagerProjectFolderItem* _tmp10_;
#line 250 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 250 "../src/FolderManager/FileView.vala"
	g_return_if_fail (folder != NULL);
#line 250 "../src/FolderManager/FileView.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 250 "../src/FolderManager/FileView.vala"
	_data7_->_ref_count_ = 1;
#line 250 "../src/FolderManager/FileView.vala"
	_data7_->self = g_object_ref (self);
#line 251 "../src/FolderManager/FileView.vala"
	if (scratch_folder_manager_file_view_is_open (self, folder)) {
#line 2123 "FileView.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 252 "../src/FolderManager/FileView.vala"
		_tmp0_ = scratch_folder_manager_file_get_path (folder);
#line 252 "../src/FolderManager/FileView.vala"
		_tmp1_ = _tmp0_;
#line 252 "../src/FolderManager/FileView.vala"
		_tmp2_ = _tmp1_;
#line 252 "../src/FolderManager/FileView.vala"
		g_warning ("FileView.vala:252: Folder '%s' is already open.", _tmp2_);
#line 252 "../src/FolderManager/FileView.vala"
		_g_free0 (_tmp2_);
#line 253 "../src/FolderManager/FileView.vala"
		block7_data_unref (_data7_);
#line 253 "../src/FolderManager/FileView.vala"
		_data7_ = NULL;
#line 253 "../src/FolderManager/FileView.vala"
		return;
#line 2143 "FileView.c"
	} else {
#line 254 "../src/FolderManager/FileView.vala"
		if (!scratch_folder_manager_file_is_valid_directory (folder, TRUE)) {
#line 255 "../src/FolderManager/FileView.vala"
			g_warning ("FileView.vala:255: Cannot open invalid directory.");
#line 256 "../src/FolderManager/FileView.vala"
			block7_data_unref (_data7_);
#line 256 "../src/FolderManager/FileView.vala"
			_data7_ = NULL;
#line 256 "../src/FolderManager/FileView.vala"
			return;
#line 2155 "FileView.c"
		}
	}
#line 259 "../src/FolderManager/FileView.vala"
	_tmp3_ = scratch_folder_manager_project_folder_item_new (folder, self);
#line 259 "../src/FolderManager/FileView.vala"
	_data7_->folder_root = _tmp3_;
#line 260 "../src/FolderManager/FileView.vala"
	_tmp4_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 260 "../src/FolderManager/FileView.vala"
	_tmp5_ = _tmp4_;
#line 260 "../src/FolderManager/FileView.vala"
	_tmp6_ = _data7_->folder_root;
#line 260 "../src/FolderManager/FileView.vala"
	granite_widgets_source_list_expandable_item_add (_tmp5_, (GraniteWidgetsSourceListItem*) _tmp6_);
#line 261 "../src/FolderManager/FileView.vala"
	_tmp7_ = _data7_->folder_root;
#line 261 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_rename_items_with_same_name (self, (ScratchFolderManagerItem*) _tmp7_);
#line 263 "../src/FolderManager/FileView.vala"
	_tmp8_ = _data7_->folder_root;
#line 263 "../src/FolderManager/FileView.vala"
	granite_widgets_source_list_expandable_item_set_expanded ((GraniteWidgetsSourceListExpandableItem*) _tmp8_, expand);
#line 264 "../src/FolderManager/FileView.vala"
	_tmp9_ = _data7_->folder_root;
#line 264 "../src/FolderManager/FileView.vala"
	g_signal_connect_data (_tmp9_, "closed", (GCallback) ___lambda41__scratch_folder_manager_project_folder_item_closed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 277 "../src/FolderManager/FileView.vala"
	_tmp10_ = _data7_->folder_root;
#line 277 "../src/FolderManager/FileView.vala"
	g_signal_connect_data (_tmp10_, "close-all-except", (GCallback) ___lambda42__scratch_folder_manager_project_folder_item_close_all_except, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 290 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_write_settings (self);
#line 250 "../src/FolderManager/FileView.vala"
	block7_data_unref (_data7_);
#line 250 "../src/FolderManager/FileView.vala"
	_data7_ = NULL;
#line 2192 "FileView.c"
}

static gboolean
scratch_folder_manager_file_view_is_open (ScratchFolderManagerFileView* self,
                                          ScratchFolderManagerFile* folder)
{
	gboolean result;
#line 293 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 293 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (folder != NULL, FALSE);
#line 2204 "FileView.c"
	{
		GeeIterator* _child_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 294 "../src/FolderManager/FileView.vala"
		_tmp0_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 294 "../src/FolderManager/FileView.vala"
		_tmp1_ = _tmp0_;
#line 294 "../src/FolderManager/FileView.vala"
		_tmp2_ = granite_widgets_source_list_expandable_item_get_children (_tmp1_);
#line 294 "../src/FolderManager/FileView.vala"
		_tmp3_ = _tmp2_;
#line 294 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 294 "../src/FolderManager/FileView.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 294 "../src/FolderManager/FileView.vala"
		_tmp6_ = _tmp5_;
#line 294 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp4_);
#line 294 "../src/FolderManager/FileView.vala"
		_child_it = _tmp6_;
#line 294 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 2234 "FileView.c"
			GeeIterator* _tmp7_;
			GraniteWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			GraniteWidgetsSourceListItem* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gboolean _tmp17_;
#line 294 "../src/FolderManager/FileView.vala"
			_tmp7_ = _child_it;
#line 294 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 294 "../src/FolderManager/FileView.vala"
				break;
#line 2253 "FileView.c"
			}
#line 294 "../src/FolderManager/FileView.vala"
			_tmp8_ = _child_it;
#line 294 "../src/FolderManager/FileView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 294 "../src/FolderManager/FileView.vala"
			child = (GraniteWidgetsSourceListItem*) _tmp9_;
#line 295 "../src/FolderManager/FileView.vala"
			_tmp10_ = scratch_folder_manager_file_get_path (folder);
#line 295 "../src/FolderManager/FileView.vala"
			_tmp11_ = _tmp10_;
#line 295 "../src/FolderManager/FileView.vala"
			_tmp12_ = _tmp11_;
#line 295 "../src/FolderManager/FileView.vala"
			_tmp13_ = child;
#line 295 "../src/FolderManager/FileView.vala"
			_tmp14_ = scratch_folder_manager_item_get_path (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, SCRATCH_FOLDER_MANAGER_TYPE_ITEM, ScratchFolderManagerItem));
#line 295 "../src/FolderManager/FileView.vala"
			_tmp15_ = _tmp14_;
#line 295 "../src/FolderManager/FileView.vala"
			_tmp16_ = _tmp15_;
#line 295 "../src/FolderManager/FileView.vala"
			_tmp17_ = g_strcmp0 (_tmp12_, _tmp16_) == 0;
#line 295 "../src/FolderManager/FileView.vala"
			_g_free0 (_tmp16_);
#line 295 "../src/FolderManager/FileView.vala"
			_g_free0 (_tmp12_);
#line 295 "../src/FolderManager/FileView.vala"
			if (_tmp17_) {
#line 296 "../src/FolderManager/FileView.vala"
				result = TRUE;
#line 296 "../src/FolderManager/FileView.vala"
				_g_object_unref0 (child);
#line 296 "../src/FolderManager/FileView.vala"
				_g_object_unref0 (_child_it);
#line 296 "../src/FolderManager/FileView.vala"
				return result;
#line 2291 "FileView.c"
			}
#line 294 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 2295 "FileView.c"
		}
#line 294 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 2299 "FileView.c"
	}
#line 297 "../src/FolderManager/FileView.vala"
	result = FALSE;
#line 297 "../src/FolderManager/FileView.vala"
	return result;
#line 2305 "FileView.c"
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 315 "../src/FolderManager/FileView.vala"
	if ((*length) == (*size)) {
#line 315 "../src/FolderManager/FileView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 315 "../src/FolderManager/FileView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2320 "FileView.c"
	}
#line 315 "../src/FolderManager/FileView.vala"
	(*array)[(*length)++] = value;
#line 315 "../src/FolderManager/FileView.vala"
	(*array)[*length] = NULL;
#line 2326 "FileView.c"
}

static void
scratch_folder_manager_file_view_write_settings (ScratchFolderManagerFileView* self)
{
	gchar** to_save = NULL;
	gchar** _tmp0_;
	gint to_save_length1;
	gint _to_save_size_;
	GSettings* _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
#line 300 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 301 "../src/FolderManager/FileView.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 301 "../src/FolderManager/FileView.vala"
	to_save = _tmp0_;
#line 301 "../src/FolderManager/FileView.vala"
	to_save_length1 = 0;
#line 301 "../src/FolderManager/FileView.vala"
	_to_save_size_ = to_save_length1;
#line 2349 "FileView.c"
	{
		GeeIterator* _main_folder_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GraniteWidgetsSourceListExpandableItem* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeIterator* _tmp6_;
		GeeIterator* _tmp7_;
#line 303 "../src/FolderManager/FileView.vala"
		_tmp1_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 303 "../src/FolderManager/FileView.vala"
		_tmp2_ = _tmp1_;
#line 303 "../src/FolderManager/FileView.vala"
		_tmp3_ = granite_widgets_source_list_expandable_item_get_children (_tmp2_);
#line 303 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 303 "../src/FolderManager/FileView.vala"
		_tmp5_ = _tmp4_;
#line 303 "../src/FolderManager/FileView.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 303 "../src/FolderManager/FileView.vala"
		_tmp7_ = _tmp6_;
#line 303 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp5_);
#line 303 "../src/FolderManager/FileView.vala"
		_main_folder_it = _tmp7_;
#line 303 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 2379 "FileView.c"
			GeeIterator* _tmp8_;
			GraniteWidgetsSourceListItem* main_folder = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			gboolean saved = FALSE;
			gchar* folder_path = NULL;
			GraniteWidgetsSourceListItem* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar** _tmp14_;
			gint _tmp14__length1;
#line 303 "../src/FolderManager/FileView.vala"
			_tmp8_ = _main_folder_it;
#line 303 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp8_)) {
#line 303 "../src/FolderManager/FileView.vala"
				break;
#line 2397 "FileView.c"
			}
#line 303 "../src/FolderManager/FileView.vala"
			_tmp9_ = _main_folder_it;
#line 303 "../src/FolderManager/FileView.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 303 "../src/FolderManager/FileView.vala"
			main_folder = (GraniteWidgetsSourceListItem*) _tmp10_;
#line 304 "../src/FolderManager/FileView.vala"
			saved = FALSE;
#line 305 "../src/FolderManager/FileView.vala"
			_tmp11_ = main_folder;
#line 305 "../src/FolderManager/FileView.vala"
			_tmp12_ = scratch_folder_manager_item_get_path (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, SCRATCH_FOLDER_MANAGER_TYPE_ITEM, ScratchFolderManagerItem));
#line 305 "../src/FolderManager/FileView.vala"
			_tmp13_ = _tmp12_;
#line 305 "../src/FolderManager/FileView.vala"
			folder_path = _tmp13_;
#line 307 "../src/FolderManager/FileView.vala"
			_tmp14_ = to_save;
#line 307 "../src/FolderManager/FileView.vala"
			_tmp14__length1 = to_save_length1;
#line 2419 "FileView.c"
			{
				gchar** saved_folder_collection = NULL;
				gint saved_folder_collection_length1 = 0;
				gint _saved_folder_collection_size_ = 0;
				gint saved_folder_it = 0;
#line 307 "../src/FolderManager/FileView.vala"
				saved_folder_collection = _tmp14_;
#line 307 "../src/FolderManager/FileView.vala"
				saved_folder_collection_length1 = _tmp14__length1;
#line 307 "../src/FolderManager/FileView.vala"
				for (saved_folder_it = 0; saved_folder_it < saved_folder_collection_length1; saved_folder_it = saved_folder_it + 1) {
#line 2431 "FileView.c"
					gchar* _tmp15_;
					gchar* saved_folder = NULL;
#line 307 "../src/FolderManager/FileView.vala"
					_tmp15_ = g_strdup (saved_folder_collection[saved_folder_it]);
#line 307 "../src/FolderManager/FileView.vala"
					saved_folder = _tmp15_;
#line 2438 "FileView.c"
					{
						const gchar* _tmp16_;
						const gchar* _tmp17_;
#line 308 "../src/FolderManager/FileView.vala"
						_tmp16_ = folder_path;
#line 308 "../src/FolderManager/FileView.vala"
						_tmp17_ = saved_folder;
#line 308 "../src/FolderManager/FileView.vala"
						if (g_strcmp0 (_tmp16_, _tmp17_) == 0) {
#line 309 "../src/FolderManager/FileView.vala"
							saved = TRUE;
#line 310 "../src/FolderManager/FileView.vala"
							_g_free0 (saved_folder);
#line 310 "../src/FolderManager/FileView.vala"
							break;
#line 2454 "FileView.c"
						}
#line 307 "../src/FolderManager/FileView.vala"
						_g_free0 (saved_folder);
#line 2458 "FileView.c"
					}
				}
			}
#line 314 "../src/FolderManager/FileView.vala"
			if (!saved) {
#line 2464 "FileView.c"
				const gchar* _tmp18_;
				gchar* _tmp19_;
#line 315 "../src/FolderManager/FileView.vala"
				_tmp18_ = folder_path;
#line 315 "../src/FolderManager/FileView.vala"
				_tmp19_ = g_strdup (_tmp18_);
#line 315 "../src/FolderManager/FileView.vala"
				_vala_array_add3 (&to_save, &to_save_length1, &_to_save_size_, _tmp19_);
#line 2473 "FileView.c"
			}
#line 303 "../src/FolderManager/FileView.vala"
			_g_free0 (folder_path);
#line 303 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (main_folder);
#line 2479 "FileView.c"
		}
#line 303 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_main_folder_it);
#line 2483 "FileView.c"
	}
#line 319 "../src/FolderManager/FileView.vala"
	_tmp20_ = self->priv->settings;
#line 319 "../src/FolderManager/FileView.vala"
	_tmp21_ = to_save;
#line 319 "../src/FolderManager/FileView.vala"
	_tmp21__length1 = to_save_length1;
#line 319 "../src/FolderManager/FileView.vala"
	g_settings_set_strv (_tmp20_, "opened-folders", _tmp21_);
#line 300 "../src/FolderManager/FileView.vala"
	to_save = (_vala_array_free (to_save, to_save_length1, (GDestroyNotify) g_free), NULL);
#line 2495 "FileView.c"
}

ScratchFolderManagerFileView*
scratch_folder_manager_file_view_construct (GType object_type)
{
	ScratchFolderManagerFileView * self = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
#line 24 "../src/FolderManager/FileView.vala"
	_tmp0_ = granite_widgets_source_list_expandable_item_new ("");
#line 24 "../src/FolderManager/FileView.vala"
	_tmp1_ = _tmp0_;
#line 24 "../src/FolderManager/FileView.vala"
	self = (ScratchFolderManagerFileView*) granite_widgets_source_list_construct (object_type, _tmp1_);
#line 24 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (_tmp1_);
#line 24 "../src/FolderManager/FileView.vala"
	return self;
#line 2514 "FileView.c"
}

ScratchFolderManagerFileView*
scratch_folder_manager_file_view_new (void)
{
#line 24 "../src/FolderManager/FileView.vala"
	return scratch_folder_manager_file_view_construct (SCRATCH_FOLDER_MANAGER_TYPE_FILE_VIEW);
#line 2522 "FileView.c"
}

gboolean
scratch_folder_manager_file_view_get_ignore_next_select (ScratchFolderManagerFileView* self)
{
	gboolean result;
#line 31 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../src/FolderManager/FileView.vala"
	result = self->priv->_ignore_next_select;
#line 31 "../src/FolderManager/FileView.vala"
	return result;
#line 2535 "FileView.c"
}

void
scratch_folder_manager_file_view_set_ignore_next_select (ScratchFolderManagerFileView* self,
                                                         gboolean value)
{
	gboolean old_value;
#line 31 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/FolderManager/FileView.vala"
	old_value = scratch_folder_manager_file_view_get_ignore_next_select (self);
#line 31 "../src/FolderManager/FileView.vala"
	if (old_value != value) {
#line 31 "../src/FolderManager/FileView.vala"
		self->priv->_ignore_next_select = value;
#line 31 "../src/FolderManager/FileView.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_IGNORE_NEXT_SELECT_PROPERTY]);
#line 2553 "FileView.c"
	}
}

static const gchar*
scratch_folder_manager_file_view_real_get_icon_name (CodePaneSwitcher* base)
{
	const gchar* result;
	ScratchFolderManagerFileView* self;
	const gchar* _tmp0_;
#line 32 "../src/FolderManager/FileView.vala"
	self = (ScratchFolderManagerFileView*) base;
#line 32 "../src/FolderManager/FileView.vala"
	_tmp0_ = self->priv->_icon_name;
#line 32 "../src/FolderManager/FileView.vala"
	result = _tmp0_;
#line 32 "../src/FolderManager/FileView.vala"
	return result;
#line 2571 "FileView.c"
}

static void
scratch_folder_manager_file_view_real_set_icon_name (CodePaneSwitcher* base,
                                                     const gchar* value)
{
	ScratchFolderManagerFileView* self;
	gchar* old_value;
#line 32 "../src/FolderManager/FileView.vala"
	self = (ScratchFolderManagerFileView*) base;
#line 32 "../src/FolderManager/FileView.vala"
	old_value = scratch_folder_manager_file_view_real_get_icon_name (base);
#line 32 "../src/FolderManager/FileView.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2586 "FileView.c"
		gchar* _tmp0_;
#line 32 "../src/FolderManager/FileView.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../src/FolderManager/FileView.vala"
		_g_free0 (self->priv->_icon_name);
#line 32 "../src/FolderManager/FileView.vala"
		self->priv->_icon_name = _tmp0_;
#line 32 "../src/FolderManager/FileView.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_ICON_NAME_PROPERTY]);
#line 2596 "FileView.c"
	}
}

static const gchar*
scratch_folder_manager_file_view_real_get_title (CodePaneSwitcher* base)
{
	const gchar* result;
	ScratchFolderManagerFileView* self;
	const gchar* _tmp0_;
#line 33 "../src/FolderManager/FileView.vala"
	self = (ScratchFolderManagerFileView*) base;
#line 33 "../src/FolderManager/FileView.vala"
	_tmp0_ = self->priv->_title;
#line 33 "../src/FolderManager/FileView.vala"
	result = _tmp0_;
#line 33 "../src/FolderManager/FileView.vala"
	return result;
#line 2614 "FileView.c"
}

static void
scratch_folder_manager_file_view_real_set_title (CodePaneSwitcher* base,
                                                 const gchar* value)
{
	ScratchFolderManagerFileView* self;
	gchar* old_value;
#line 33 "../src/FolderManager/FileView.vala"
	self = (ScratchFolderManagerFileView*) base;
#line 33 "../src/FolderManager/FileView.vala"
	old_value = scratch_folder_manager_file_view_real_get_title (base);
#line 33 "../src/FolderManager/FileView.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2629 "FileView.c"
		gchar* _tmp0_;
#line 33 "../src/FolderManager/FileView.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/FolderManager/FileView.vala"
		_g_free0 (self->priv->_title);
#line 33 "../src/FolderManager/FileView.vala"
		self->priv->_title = _tmp0_;
#line 33 "../src/FolderManager/FileView.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_TITLE_PROPERTY]);
#line 2639 "FileView.c"
	}
}

const gchar*
scratch_folder_manager_file_view_get_active_project_path (ScratchFolderManagerFileView* self)
{
	const gchar* result;
	ScratchServicesGitManager* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 35 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/FolderManager/FileView.vala"
	_tmp0_ = self->priv->git_manager;
#line 36 "../src/FolderManager/FileView.vala"
	_tmp1_ = scratch_services_git_manager_get_active_project_path (_tmp0_);
#line 36 "../src/FolderManager/FileView.vala"
	_tmp2_ = _tmp1_;
#line 36 "../src/FolderManager/FileView.vala"
	result = _tmp2_;
#line 36 "../src/FolderManager/FileView.vala"
	return result;
#line 2662 "FileView.c"
}

static void
_scratch_folder_manager_file_view___lambda49_ (ScratchFolderManagerFileView* self)
{
	GActionGroup* _tmp0_;
	GActionGroup* _tmp1_;
	GActionGroup* _tmp2_;
#line 51 "../src/FolderManager/FileView.vala"
	_tmp0_ = gtk_widget_get_action_group ((GtkWidget*) self, SCRATCH_MAIN_WINDOW_ACTION_GROUP);
#line 51 "../src/FolderManager/FileView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 51 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (self->priv->toplevel_action_group);
#line 51 "../src/FolderManager/FileView.vala"
	self->priv->toplevel_action_group = _tmp1_;
#line 52 "../src/FolderManager/FileView.vala"
	_tmp2_ = self->priv->toplevel_action_group;
#line 52 "../src/FolderManager/FileView.vala"
	g_assert_nonnull (_tmp2_);
#line 2683 "FileView.c"
}

static void
__scratch_folder_manager_file_view___lambda49__gtk_widget_realize (GtkWidget* _sender,
                                                                   gpointer self)
{
#line 50 "../src/FolderManager/FileView.vala"
	_scratch_folder_manager_file_view___lambda49_ ((ScratchFolderManagerFileView*) self);
#line 2692 "FileView.c"
}

static GObject *
scratch_folder_manager_file_view_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ScratchFolderManagerFileView * self;
	GSettings* _tmp0_;
	ScratchServicesGitManager* _tmp1_;
#line 40 "../src/FolderManager/FileView.vala"
	parent_class = G_OBJECT_CLASS (scratch_folder_manager_file_view_parent_class);
#line 40 "../src/FolderManager/FileView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 40 "../src/FolderManager/FileView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_FOLDER_MANAGER_TYPE_FILE_VIEW, ScratchFolderManagerFileView);
#line 41 "../src/FolderManager/FileView.vala"
	code_pane_switcher_set_icon_name ((CodePaneSwitcher*) self, "folder-symbolic");
#line 42 "../src/FolderManager/FileView.vala"
	code_pane_switcher_set_title ((CodePaneSwitcher*) self, _ ("Folders"));
#line 44 "../src/FolderManager/FileView.vala"
	g_signal_connect_object ((GraniteWidgetsSourceList*) self, "item-selected", (GCallback) _scratch_folder_manager_file_view_on_item_selected_granite_widgets_source_list_item_selected, self, 0);
#line 46 "../src/FolderManager/FileView.vala"
	_tmp0_ = g_settings_new ("io.elementary.code.folder-manager");
#line 46 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (self->priv->settings);
#line 46 "../src/FolderManager/FileView.vala"
	self->priv->settings = _tmp0_;
#line 48 "../src/FolderManager/FileView.vala"
	_tmp1_ = scratch_services_git_manager_get_instance ();
#line 48 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (self->priv->git_manager);
#line 48 "../src/FolderManager/FileView.vala"
	self->priv->git_manager = _tmp1_;
#line 50 "../src/FolderManager/FileView.vala"
	g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) __scratch_folder_manager_file_view___lambda49__gtk_widget_realize, self, 0);
#line 40 "../src/FolderManager/FileView.vala"
	return obj;
#line 2733 "FileView.c"
}

static void
scratch_folder_manager_file_view_class_init (ScratchFolderManagerFileViewClass * klass,
                                             gpointer klass_data)
{
#line 24 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/FolderManager/FileView.vala"
	g_type_class_adjust_private_offset (klass, &ScratchFolderManagerFileView_private_offset);
#line 24 "../src/FolderManager/FileView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_scratch_folder_manager_file_view_get_property;
#line 24 "../src/FolderManager/FileView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_scratch_folder_manager_file_view_set_property;
#line 24 "../src/FolderManager/FileView.vala"
	G_OBJECT_CLASS (klass)->constructor = scratch_folder_manager_file_view_constructor;
#line 24 "../src/FolderManager/FileView.vala"
	G_OBJECT_CLASS (klass)->finalize = scratch_folder_manager_file_view_finalize;
#line 24 "../src/FolderManager/FileView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_VIEW_IGNORE_NEXT_SELECT_PROPERTY, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_IGNORE_NEXT_SELECT_PROPERTY] = g_param_spec_boolean ("ignore-next-select", "ignore-next-select", "ignore-next-select", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/FolderManager/FileView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_VIEW_ICON_NAME_PROPERTY, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/FolderManager/FileView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_VIEW_TITLE_PROPERTY, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/FolderManager/FileView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTIVE_PROJECT_PATH_PROPERTY, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTIVE_PROJECT_PATH_PROPERTY] = g_param_spec_string ("active-project-path", "active-project-path", "active-project-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_signals[SCRATCH_FOLDER_MANAGER_FILE_VIEW_SELECT_SIGNAL] = g_signal_new ("select", SCRATCH_FOLDER_MANAGER_TYPE_FILE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 2762 "FileView.c"
}

static void
scratch_folder_manager_file_view_code_pane_switcher_interface_init (CodePaneSwitcherIface * iface,
                                                                    gpointer iface_data)
{
#line 24 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_code_pane_switcher_parent_iface = g_type_interface_peek_parent (iface);
#line 24 "../src/FolderManager/FileView.vala"
	iface->get_icon_name = scratch_folder_manager_file_view_real_get_icon_name;
#line 24 "../src/FolderManager/FileView.vala"
	iface->set_icon_name = scratch_folder_manager_file_view_real_set_icon_name;
#line 24 "../src/FolderManager/FileView.vala"
	iface->get_title = scratch_folder_manager_file_view_real_get_title;
#line 24 "../src/FolderManager/FileView.vala"
	iface->set_title = scratch_folder_manager_file_view_real_set_title;
#line 2779 "FileView.c"
}

static void
scratch_folder_manager_file_view_instance_init (ScratchFolderManagerFileView * self,
                                                gpointer klass)
{
#line 24 "../src/FolderManager/FileView.vala"
	self->priv = scratch_folder_manager_file_view_get_instance_private (self);
#line 27 "../src/FolderManager/FileView.vala"
	self->priv->toplevel_action_group = NULL;
#line 31 "../src/FolderManager/FileView.vala"
	self->priv->_ignore_next_select = FALSE;
#line 2792 "FileView.c"
}

static void
scratch_folder_manager_file_view_finalize (GObject * obj)
{
	ScratchFolderManagerFileView * self;
#line 24 "../src/FolderManager/FileView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_FOLDER_MANAGER_TYPE_FILE_VIEW, ScratchFolderManagerFileView);
#line 25 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (self->priv->settings);
#line 26 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (self->priv->git_manager);
#line 27 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (self->priv->toplevel_action_group);
#line 32 "../src/FolderManager/FileView.vala"
	_g_free0 (self->priv->_icon_name);
#line 33 "../src/FolderManager/FileView.vala"
	_g_free0 (self->priv->_title);
#line 24 "../src/FolderManager/FileView.vala"
	G_OBJECT_CLASS (scratch_folder_manager_file_view_parent_class)->finalize (obj);
#line 2813 "FileView.c"
}

/**
 * SourceList that displays folders and their contents.
 */
static GType
scratch_folder_manager_file_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScratchFolderManagerFileViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scratch_folder_manager_file_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScratchFolderManagerFileView), 0, (GInstanceInitFunc) scratch_folder_manager_file_view_instance_init, NULL };
	static const GInterfaceInfo code_pane_switcher_info = { (GInterfaceInitFunc) scratch_folder_manager_file_view_code_pane_switcher_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType scratch_folder_manager_file_view_type_id;
	scratch_folder_manager_file_view_type_id = g_type_register_static (GRANITE_WIDGETS_TYPE_SOURCE_LIST, "ScratchFolderManagerFileView", &g_define_type_info, 0);
	g_type_add_interface_static (scratch_folder_manager_file_view_type_id, CODE_TYPE_PANE_SWITCHER, &code_pane_switcher_info);
	ScratchFolderManagerFileView_private_offset = g_type_add_instance_private (scratch_folder_manager_file_view_type_id, sizeof (ScratchFolderManagerFileViewPrivate));
	return scratch_folder_manager_file_view_type_id;
}

GType
scratch_folder_manager_file_view_get_type (void)
{
	static volatile gsize scratch_folder_manager_file_view_type_id__once = 0;
	if (g_once_init_enter (&scratch_folder_manager_file_view_type_id__once)) {
		GType scratch_folder_manager_file_view_type_id;
		scratch_folder_manager_file_view_type_id = scratch_folder_manager_file_view_get_type_once ();
		g_once_init_leave (&scratch_folder_manager_file_view_type_id__once, scratch_folder_manager_file_view_type_id);
	}
	return scratch_folder_manager_file_view_type_id__once;
}

static void
_vala_scratch_folder_manager_file_view_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec)
{
	ScratchFolderManagerFileView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_FOLDER_MANAGER_TYPE_FILE_VIEW, ScratchFolderManagerFileView);
#line 24 "../src/FolderManager/FileView.vala"
	switch (property_id) {
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_IGNORE_NEXT_SELECT_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		g_value_set_boolean (value, scratch_folder_manager_file_view_get_ignore_next_select (self));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_ICON_NAME_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		g_value_set_string (value, code_pane_switcher_get_icon_name ((CodePaneSwitcher*) self));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_TITLE_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		g_value_set_string (value, code_pane_switcher_get_title ((CodePaneSwitcher*) self));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTIVE_PROJECT_PATH_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		g_value_set_string (value, scratch_folder_manager_file_view_get_active_project_path (self));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 2877 "FileView.c"
		default:
#line 24 "../src/FolderManager/FileView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 2883 "FileView.c"
	}
}

static void
_vala_scratch_folder_manager_file_view_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec)
{
	ScratchFolderManagerFileView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_FOLDER_MANAGER_TYPE_FILE_VIEW, ScratchFolderManagerFileView);
#line 24 "../src/FolderManager/FileView.vala"
	switch (property_id) {
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_IGNORE_NEXT_SELECT_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		scratch_folder_manager_file_view_set_ignore_next_select (self, g_value_get_boolean (value));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_ICON_NAME_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		code_pane_switcher_set_icon_name ((CodePaneSwitcher*) self, g_value_get_string (value));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_TITLE_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		code_pane_switcher_set_title ((CodePaneSwitcher*) self, g_value_get_string (value));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 2915 "FileView.c"
		default:
#line 24 "../src/FolderManager/FileView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 2921 "FileView.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

