/* MonitoredRepository.c generated by valac 0.56.14, the Vala compiler
 * generated from MonitoredRepository.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2020 elementary LLC. (https://elementary.io),
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Jeremy Wootten <jeremy@elementaryos.org>
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "codecore.h"
#include <libgit2-glib/ggit.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>

enum  {
	SCRATCH_SERVICES_MONITORED_REPOSITORY_0_PROPERTY,
	SCRATCH_SERVICES_MONITORED_REPOSITORY_GIT_REPO_PROPERTY,
	SCRATCH_SERVICES_MONITORED_REPOSITORY_BRANCH_NAME_PROPERTY,
	SCRATCH_SERVICES_MONITORED_REPOSITORY_HEAD_IS_BRANCH_PROPERTY,
	SCRATCH_SERVICES_MONITORED_REPOSITORY_NON_CURRENT_ENTRIES_PROPERTY,
	SCRATCH_SERVICES_MONITORED_REPOSITORY_HAS_UNCOMMITTED_PROPERTY,
	SCRATCH_SERVICES_MONITORED_REPOSITORY_NUM_PROPERTIES
};
static GParamSpec* scratch_services_monitored_repository_properties[SCRATCH_SERVICES_MONITORED_REPOSITORY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GgitStatusOptions_free0(var) ((var == NULL) ? NULL : (var = (_vala_GgitStatusOptions_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _ggit_branch_enumerator_unref0(var) ((var == NULL) ? NULL : (var = (ggit_branch_enumerator_unref (var), NULL)))
#define __vala_GgitOId_free0(var) ((var == NULL) ? NULL : (var = (_vala_GgitOId_free (var), NULL)))
typedef struct _Block23Data Block23Data;
enum  {
	SCRATCH_SERVICES_MONITORED_REPOSITORY_BRANCH_CHANGED_SIGNAL,
	SCRATCH_SERVICES_MONITORED_REPOSITORY_IGNORED_CHANGED_SIGNAL,
	SCRATCH_SERVICES_MONITORED_REPOSITORY_FILE_STATUS_CHANGE_SIGNAL,
	SCRATCH_SERVICES_MONITORED_REPOSITORY_FILE_CONTENT_CHANGED_SIGNAL,
	SCRATCH_SERVICES_MONITORED_REPOSITORY_NUM_SIGNALS
};
static guint scratch_services_monitored_repository_signals[SCRATCH_SERVICES_MONITORED_REPOSITORY_NUM_SIGNALS] = {0};

struct _ScratchServicesMonitoredRepositoryPrivate {
	GgitRepository* _git_repo;
	GFileMonitor* git_monitor;
	GFileMonitor* gitignore_monitor;
	gchar* _branch_name;
	guint update_timer_id;
	GgitStatusOptions* status_options;
	GeeHashMap* file_status_map;
	gboolean do_update;
	gboolean refreshing;
};

struct _Block23Data {
	int _ref_count_;
	ScratchServicesMonitoredRepository* self;
	GeeHashMap* status_map;
	gint prev_deletions;
	gint prev_additions;
	gchar* file_path;
};

static gint ScratchServicesMonitoredRepository_private_offset;
static gpointer scratch_services_monitored_repository_parent_class = NULL;

static void _vala_GgitStatusOptions_free (GgitStatusOptions* self);
static void ___lambda4_ (ScratchServicesMonitoredRepository* self);
static void ____lambda4__g_file_monitor_changed (GFileMonitor* _sender,
                                          GFile* file,
                                          GFile* other_file,
                                          GFileMonitorEvent event_type,
                                          gpointer self);
static void ____lambda7_ (ScratchServicesMonitoredRepository* self);
static void _____lambda7__g_file_monitor_changed (GFileMonitor* _sender,
                                           GFile* file,
                                           GFile* other_file,
                                           GFileMonitorEvent event_type,
                                           gpointer self);
static gboolean ___lambda5_ (ScratchServicesMonitoredRepository* self);
static void _vala_GgitOId_free (GgitOId* self);
static gint ____lambda6_ (ScratchServicesMonitoredRepository* self,
                   const gchar* path,
                   GgitStatusFlags status);
static gint _____lambda6__ggit_status_callback (const gchar* path,
                                         GgitStatusFlags status_flags,
                                         gpointer self);
static gboolean ____lambda5__gsource_func (gpointer self);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
static gint ___lambda8_ (Block23Data* _data23_,
                  GgitDiffDelta* delta,
                  GgitDiffHunk* hunk,
                  GgitDiffLine* line);
static void scratch_services_monitored_repository_process_diff_line (ScratchServicesMonitoredRepository* self,
                                                              GgitDiffLineType line_type,
                                                              gint new_line_no,
                                                              gint old_line_no,
                                                              GeeHashMap** line_status_map,
                                                              gint* prev_deletions,
                                                              gint* prev_additions);
static gint ____lambda8__ggit_diff_line_callback (GgitDiffDelta* delta,
                                           GgitDiffHunk* hunk,
                                           GgitDiffLine* line,
                                           gpointer self);
static gboolean _scratch_services_monitored_repository_has_uncommitted___lambda9_ (ScratchServicesMonitoredRepository* self,
                                                                            GgitStatusFlags* status);
static gboolean __scratch_services_monitored_repository_has_uncommitted___lambda9__gee_predicate (gconstpointer g,
                                                                                           gpointer self);
static GObject * scratch_services_monitored_repository_constructor (GType type,
                                                             guint n_construct_properties,
                                                             GObjectConstructParam * construct_properties);
static GgitStatusFlags* _ggit_status_flags_dup (GgitStatusFlags* self);
static void scratch_services_monitored_repository_finalize (GObject * obj);
static GType scratch_services_monitored_repository_get_type_once (void);
static void _vala_scratch_services_monitored_repository_get_property (GObject * object,
                                                               guint property_id,
                                                               GValue * value,
                                                               GParamSpec * pspec);
static void _vala_scratch_services_monitored_repository_set_property (GObject * object,
                                                               guint property_id,
                                                               const GValue * value,
                                                               GParamSpec * pspec);

static GType
scratch_services_vc_status_get_type_once (void)
{
	static const GEnumValue values[] = {{SCRATCH_SERVICES_VC_STATUS_NONE, "SCRATCH_SERVICES_VC_STATUS_NONE", "none"}, {SCRATCH_SERVICES_VC_STATUS_ADDED, "SCRATCH_SERVICES_VC_STATUS_ADDED", "added"}, {SCRATCH_SERVICES_VC_STATUS_CHANGED, "SCRATCH_SERVICES_VC_STATUS_CHANGED", "changed"}, {SCRATCH_SERVICES_VC_STATUS_REMOVED, "SCRATCH_SERVICES_VC_STATUS_REMOVED", "removed"}, {SCRATCH_SERVICES_VC_STATUS_REPLACES_DELETED, "SCRATCH_SERVICES_VC_STATUS_REPLACES_DELETED", "replaces-deleted"}, {SCRATCH_SERVICES_VC_STATUS_OTHER, "SCRATCH_SERVICES_VC_STATUS_OTHER", "other"}, {0, NULL, NULL}};
	GType scratch_services_vc_status_type_id;
	scratch_services_vc_status_type_id = g_enum_register_static ("ScratchServicesVCStatus", values);
	return scratch_services_vc_status_type_id;
}

GType
scratch_services_vc_status_get_type (void)
{
	static volatile gsize scratch_services_vc_status_type_id__once = 0;
	if (g_once_init_enter (&scratch_services_vc_status_type_id__once)) {
		GType scratch_services_vc_status_type_id;
		scratch_services_vc_status_type_id = scratch_services_vc_status_get_type_once ();
		g_once_init_leave (&scratch_services_vc_status_type_id__once, scratch_services_vc_status_type_id);
	}
	return scratch_services_vc_status_type_id__once;
}

static inline gpointer
scratch_services_monitored_repository_get_instance_private (ScratchServicesMonitoredRepository* self)
{
	return G_STRUCT_MEMBER_P (self, ScratchServicesMonitoredRepository_private_offset);
}

static void
_vala_GgitStatusOptions_free (GgitStatusOptions* self)
{
#line 65 "../src/Services/MonitoredRepository.vala"
	g_boxed_free (ggit_status_options_get_type (), self);
#line 181 "MonitoredRepository.c"
}

static void
___lambda4_ (ScratchServicesMonitoredRepository* self)
{
#line 112 "../src/Services/MonitoredRepository.vala"
	scratch_services_monitored_repository_update_status_map (self);
#line 189 "MonitoredRepository.c"
}

static void
____lambda4__g_file_monitor_changed (GFileMonitor* _sender,
                                     GFile* file,
                                     GFile* other_file,
                                     GFileMonitorEvent event_type,
                                     gpointer self)
{
#line 111 "../src/Services/MonitoredRepository.vala"
	___lambda4_ ((ScratchServicesMonitoredRepository*) self);
#line 201 "MonitoredRepository.c"
}

static void
____lambda7_ (ScratchServicesMonitoredRepository* self)
{
#line 125 "../src/Services/MonitoredRepository.vala"
	g_signal_emit (self, scratch_services_monitored_repository_signals[SCRATCH_SERVICES_MONITORED_REPOSITORY_IGNORED_CHANGED_SIGNAL], 0);
#line 209 "MonitoredRepository.c"
}

static void
_____lambda7__g_file_monitor_changed (GFileMonitor* _sender,
                                      GFile* file,
                                      GFile* other_file,
                                      GFileMonitorEvent event_type,
                                      gpointer self)
{
#line 125 "../src/Services/MonitoredRepository.vala"
	____lambda7_ ((ScratchServicesMonitoredRepository*) self);
#line 221 "MonitoredRepository.c"
}

ScratchServicesMonitoredRepository*
scratch_services_monitored_repository_construct (GType object_type,
                                                 GgitRepository* _git_repo)
{
	ScratchServicesMonitoredRepository * self = NULL;
	GFile* git_folder = NULL;
	GgitRepository* _tmp0_;
	GFile* _tmp1_;
	GFile* workdir = NULL;
	GgitRepository* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* gitignore_file = NULL;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 102 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (_git_repo != NULL, NULL);
#line 103 "../src/Services/MonitoredRepository.vala"
	self = (ScratchServicesMonitoredRepository*) g_object_new (object_type, "git-repo", _git_repo, NULL);
#line 107 "../src/Services/MonitoredRepository.vala"
	_tmp0_ = self->priv->_git_repo;
#line 107 "../src/Services/MonitoredRepository.vala"
	_tmp1_ = ggit_repository_get_location (_tmp0_);
#line 107 "../src/Services/MonitoredRepository.vala"
	git_folder = _tmp1_;
#line 251 "MonitoredRepository.c"
	{
		GFileMonitor* _tmp2_ = NULL;
		GFileMonitor* _tmp3_;
		GFileMonitor* _tmp4_;
		GFileMonitor* _tmp5_;
#line 110 "../src/Services/MonitoredRepository.vala"
		_tmp3_ = g_file_monitor_directory (git_folder, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 110 "../src/Services/MonitoredRepository.vala"
		_tmp2_ = _tmp3_;
#line 110 "../src/Services/MonitoredRepository.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 110 "../src/Services/MonitoredRepository.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 265 "MonitoredRepository.c"
				goto __catch0_g_io_error;
			}
#line 110 "../src/Services/MonitoredRepository.vala"
			_g_object_unref0 (git_folder);
#line 110 "../src/Services/MonitoredRepository.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 110 "../src/Services/MonitoredRepository.vala"
			g_clear_error (&_inner_error0_);
#line 110 "../src/Services/MonitoredRepository.vala"
			return NULL;
#line 276 "MonitoredRepository.c"
		}
#line 110 "../src/Services/MonitoredRepository.vala"
		_tmp4_ = _tmp2_;
#line 110 "../src/Services/MonitoredRepository.vala"
		_tmp2_ = NULL;
#line 110 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (self->priv->git_monitor);
#line 110 "../src/Services/MonitoredRepository.vala"
		self->priv->git_monitor = _tmp4_;
#line 111 "../src/Services/MonitoredRepository.vala"
		_tmp5_ = self->priv->git_monitor;
#line 111 "../src/Services/MonitoredRepository.vala"
		g_signal_connect_object (_tmp5_, "changed", (GCallback) ____lambda4__g_file_monitor_changed, self, 0);
#line 109 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (_tmp2_);
#line 292 "MonitoredRepository.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 109 "../src/Services/MonitoredRepository.vala"
		e = _inner_error0_;
#line 109 "../src/Services/MonitoredRepository.vala"
		_inner_error0_ = NULL;
#line 115 "../src/Services/MonitoredRepository.vala"
		_tmp6_ = e;
#line 115 "../src/Services/MonitoredRepository.vala"
		_tmp7_ = _tmp6_->message;
#line 115 "../src/Services/MonitoredRepository.vala"
		g_warning ("MonitoredRepository.vala:115: An error occurred setting up a file moni" \
"tor on the git folder: %s", _tmp7_);
#line 109 "../src/Services/MonitoredRepository.vala"
		_g_error_free0 (e);
#line 312 "MonitoredRepository.c"
	}
	__finally0:
#line 109 "../src/Services/MonitoredRepository.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 109 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (git_folder);
#line 109 "../src/Services/MonitoredRepository.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 109 "../src/Services/MonitoredRepository.vala"
		g_clear_error (&_inner_error0_);
#line 109 "../src/Services/MonitoredRepository.vala"
		return NULL;
#line 325 "MonitoredRepository.c"
	}
#line 120 "../src/Services/MonitoredRepository.vala"
	_tmp8_ = self->priv->_git_repo;
#line 120 "../src/Services/MonitoredRepository.vala"
	g_object_get (_tmp8_, "workdir", &_tmp9_, NULL);
#line 120 "../src/Services/MonitoredRepository.vala"
	_tmp10_ = _tmp9_;
#line 120 "../src/Services/MonitoredRepository.vala"
	workdir = _tmp10_;
#line 121 "../src/Services/MonitoredRepository.vala"
	_tmp11_ = workdir;
#line 121 "../src/Services/MonitoredRepository.vala"
	_tmp12_ = g_file_get_child (_tmp11_, ".gitignore");
#line 121 "../src/Services/MonitoredRepository.vala"
	gitignore_file = _tmp12_;
#line 122 "../src/Services/MonitoredRepository.vala"
	_tmp13_ = gitignore_file;
#line 122 "../src/Services/MonitoredRepository.vala"
	if (g_file_query_exists (_tmp13_, NULL)) {
#line 345 "MonitoredRepository.c"
		{
			GFileMonitor* _tmp14_ = NULL;
			GFile* _tmp15_;
			GFileMonitor* _tmp16_;
			GFileMonitor* _tmp17_;
			GFileMonitor* _tmp18_;
#line 124 "../src/Services/MonitoredRepository.vala"
			_tmp15_ = gitignore_file;
#line 124 "../src/Services/MonitoredRepository.vala"
			_tmp16_ = g_file_monitor_file (_tmp15_, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 124 "../src/Services/MonitoredRepository.vala"
			_tmp14_ = _tmp16_;
#line 124 "../src/Services/MonitoredRepository.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 124 "../src/Services/MonitoredRepository.vala"
				if (_inner_error0_->domain == G_IO_ERROR) {
#line 362 "MonitoredRepository.c"
					goto __catch1_g_io_error;
				}
#line 124 "../src/Services/MonitoredRepository.vala"
				_g_object_unref0 (gitignore_file);
#line 124 "../src/Services/MonitoredRepository.vala"
				_g_object_unref0 (workdir);
#line 124 "../src/Services/MonitoredRepository.vala"
				_g_object_unref0 (git_folder);
#line 124 "../src/Services/MonitoredRepository.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 124 "../src/Services/MonitoredRepository.vala"
				g_clear_error (&_inner_error0_);
#line 124 "../src/Services/MonitoredRepository.vala"
				return NULL;
#line 377 "MonitoredRepository.c"
			}
#line 124 "../src/Services/MonitoredRepository.vala"
			_tmp17_ = _tmp14_;
#line 124 "../src/Services/MonitoredRepository.vala"
			_tmp14_ = NULL;
#line 124 "../src/Services/MonitoredRepository.vala"
			_g_object_unref0 (self->priv->gitignore_monitor);
#line 124 "../src/Services/MonitoredRepository.vala"
			self->priv->gitignore_monitor = _tmp17_;
#line 125 "../src/Services/MonitoredRepository.vala"
			_tmp18_ = self->priv->gitignore_monitor;
#line 125 "../src/Services/MonitoredRepository.vala"
			g_signal_connect_object (_tmp18_, "changed", (GCallback) _____lambda7__g_file_monitor_changed, self, 0);
#line 123 "../src/Services/MonitoredRepository.vala"
			_g_object_unref0 (_tmp14_);
#line 393 "MonitoredRepository.c"
		}
		goto __finally1;
		__catch1_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp19_;
			const gchar* _tmp20_;
#line 123 "../src/Services/MonitoredRepository.vala"
			e = _inner_error0_;
#line 123 "../src/Services/MonitoredRepository.vala"
			_inner_error0_ = NULL;
#line 127 "../src/Services/MonitoredRepository.vala"
			_tmp19_ = e;
#line 127 "../src/Services/MonitoredRepository.vala"
			_tmp20_ = _tmp19_->message;
#line 127 "../src/Services/MonitoredRepository.vala"
			g_warning ("MonitoredRepository.vala:127: An error occurred setting up a file moni" \
"tor on the gitignore file: %s", _tmp20_);
#line 123 "../src/Services/MonitoredRepository.vala"
			_g_error_free0 (e);
#line 413 "MonitoredRepository.c"
		}
		__finally1:
#line 123 "../src/Services/MonitoredRepository.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 123 "../src/Services/MonitoredRepository.vala"
			_g_object_unref0 (gitignore_file);
#line 123 "../src/Services/MonitoredRepository.vala"
			_g_object_unref0 (workdir);
#line 123 "../src/Services/MonitoredRepository.vala"
			_g_object_unref0 (git_folder);
#line 123 "../src/Services/MonitoredRepository.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 123 "../src/Services/MonitoredRepository.vala"
			g_clear_error (&_inner_error0_);
#line 123 "../src/Services/MonitoredRepository.vala"
			return NULL;
#line 430 "MonitoredRepository.c"
		}
	}
#line 102 "../src/Services/MonitoredRepository.vala"
	_g_object_unref0 (gitignore_file);
#line 102 "../src/Services/MonitoredRepository.vala"
	_g_object_unref0 (workdir);
#line 102 "../src/Services/MonitoredRepository.vala"
	_g_object_unref0 (git_folder);
#line 102 "../src/Services/MonitoredRepository.vala"
	return self;
#line 441 "MonitoredRepository.c"
}

ScratchServicesMonitoredRepository*
scratch_services_monitored_repository_new (GgitRepository* _git_repo)
{
#line 102 "../src/Services/MonitoredRepository.vala"
	return scratch_services_monitored_repository_construct (SCRATCH_SERVICES_TYPE_MONITORED_REPOSITORY, _git_repo);
#line 449 "MonitoredRepository.c"
}

const gchar*
scratch_services_monitored_repository_get_current_branch (ScratchServicesMonitoredRepository* self)
{
	GError* _inner_error0_ = NULL;
	const gchar* result;
#line 142 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 459 "MonitoredRepository.c"
	{
		GgitRef* head = NULL;
		GgitRepository* _tmp0_;
		GgitRef* _tmp1_;
		GgitRef* _tmp2_;
#line 144 "../src/Services/MonitoredRepository.vala"
		_tmp0_ = self->priv->_git_repo;
#line 144 "../src/Services/MonitoredRepository.vala"
		_tmp1_ = ggit_repository_get_head (_tmp0_, &_inner_error0_);
#line 144 "../src/Services/MonitoredRepository.vala"
		head = _tmp1_;
#line 144 "../src/Services/MonitoredRepository.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 473 "MonitoredRepository.c"
			goto __catch0_g_error;
		}
#line 145 "../src/Services/MonitoredRepository.vala"
		_tmp2_ = head;
#line 145 "../src/Services/MonitoredRepository.vala"
		if (ggit_ref_is_branch (_tmp2_)) {
#line 480 "MonitoredRepository.c"
			const gchar* _tmp3_ = NULL;
			GgitRef* _tmp4_;
			const gchar* _tmp5_;
#line 146 "../src/Services/MonitoredRepository.vala"
			_tmp4_ = head;
#line 146 "../src/Services/MonitoredRepository.vala"
			_tmp5_ = ggit_branch_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, ggit_branch_get_type (), GgitBranch), &_inner_error0_);
#line 146 "../src/Services/MonitoredRepository.vala"
			_tmp3_ = _tmp5_;
#line 146 "../src/Services/MonitoredRepository.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 146 "../src/Services/MonitoredRepository.vala"
				_g_object_unref0 (head);
#line 494 "MonitoredRepository.c"
				goto __catch0_g_error;
			}
#line 146 "../src/Services/MonitoredRepository.vala"
			result = _tmp3_;
#line 146 "../src/Services/MonitoredRepository.vala"
			_g_object_unref0 (head);
#line 146 "../src/Services/MonitoredRepository.vala"
			return result;
#line 503 "MonitoredRepository.c"
		}
#line 143 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (head);
#line 507 "MonitoredRepository.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 143 "../src/Services/MonitoredRepository.vala"
		e = _inner_error0_;
#line 143 "../src/Services/MonitoredRepository.vala"
		_inner_error0_ = NULL;
#line 149 "../src/Services/MonitoredRepository.vala"
		_tmp6_ = e;
#line 149 "../src/Services/MonitoredRepository.vala"
		_tmp7_ = _tmp6_->message;
#line 149 "../src/Services/MonitoredRepository.vala"
		g_warning ("MonitoredRepository.vala:149: Could not get current branch name - %s", _tmp7_);
#line 143 "../src/Services/MonitoredRepository.vala"
		_g_error_free0 (e);
#line 527 "MonitoredRepository.c"
	}
	__finally0:
#line 143 "../src/Services/MonitoredRepository.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 143 "../src/Services/MonitoredRepository.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 143 "../src/Services/MonitoredRepository.vala"
		g_clear_error (&_inner_error0_);
#line 143 "../src/Services/MonitoredRepository.vala"
		return NULL;
#line 538 "MonitoredRepository.c"
	}
#line 152 "../src/Services/MonitoredRepository.vala"
	result = "";
#line 152 "../src/Services/MonitoredRepository.vala"
	return result;
#line 544 "MonitoredRepository.c"
}

GList*
scratch_services_monitored_repository_get_local_branches (ScratchServicesMonitoredRepository* self)
{
	GList* branches = NULL;
	GList* _tmp14_;
	GError* _inner_error0_ = NULL;
	GList* result;
#line 155 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 156 "../src/Services/MonitoredRepository.vala"
	branches = NULL;
#line 558 "MonitoredRepository.c"
	{
		GgitBranchEnumerator* branch_enumerator = NULL;
		GgitRepository* _tmp0_;
		GgitBranchEnumerator* _tmp1_;
#line 158 "../src/Services/MonitoredRepository.vala"
		_tmp0_ = self->priv->_git_repo;
#line 158 "../src/Services/MonitoredRepository.vala"
		_tmp1_ = ggit_repository_enumerate_branches (_tmp0_, GGIT_BRANCH_LOCAL, &_inner_error0_);
#line 158 "../src/Services/MonitoredRepository.vala"
		branch_enumerator = _tmp1_;
#line 158 "../src/Services/MonitoredRepository.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 571 "MonitoredRepository.c"
			goto __catch0_g_error;
		}
		{
			GgitBranchEnumerator* _branch_ref_it = NULL;
			GgitBranchEnumerator* _tmp2_;
			GgitBranchEnumerator* _tmp3_;
#line 159 "../src/Services/MonitoredRepository.vala"
			_tmp2_ = branch_enumerator;
#line 159 "../src/Services/MonitoredRepository.vala"
			_tmp3_ = ggit_branch_enumerator_iterator (_tmp2_);
#line 159 "../src/Services/MonitoredRepository.vala"
			_branch_ref_it = _tmp3_;
#line 159 "../src/Services/MonitoredRepository.vala"
			while (TRUE) {
#line 586 "MonitoredRepository.c"
				GgitBranchEnumerator* _tmp4_;
				GgitRef* branch_ref = NULL;
				GgitBranchEnumerator* _tmp5_;
				GgitRef* _tmp6_;
				GgitRef* _tmp7_;
#line 159 "../src/Services/MonitoredRepository.vala"
				_tmp4_ = _branch_ref_it;
#line 159 "../src/Services/MonitoredRepository.vala"
				if (!ggit_branch_enumerator_next (_tmp4_)) {
#line 159 "../src/Services/MonitoredRepository.vala"
					break;
#line 598 "MonitoredRepository.c"
				}
#line 159 "../src/Services/MonitoredRepository.vala"
				_tmp5_ = _branch_ref_it;
#line 159 "../src/Services/MonitoredRepository.vala"
				_tmp6_ = ggit_branch_enumerator_get (_tmp5_);
#line 159 "../src/Services/MonitoredRepository.vala"
				branch_ref = _tmp6_;
#line 160 "../src/Services/MonitoredRepository.vala"
				_tmp7_ = branch_ref;
#line 160 "../src/Services/MonitoredRepository.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, ggit_branch_get_type ())) {
#line 610 "MonitoredRepository.c"
					const gchar* _tmp8_ = NULL;
					GgitRef* _tmp9_;
					const gchar* _tmp10_;
					gchar* _tmp11_;
#line 161 "../src/Services/MonitoredRepository.vala"
					_tmp9_ = branch_ref;
#line 161 "../src/Services/MonitoredRepository.vala"
					_tmp10_ = ggit_branch_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, ggit_branch_get_type (), GgitBranch), &_inner_error0_);
#line 161 "../src/Services/MonitoredRepository.vala"
					_tmp8_ = _tmp10_;
#line 161 "../src/Services/MonitoredRepository.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 161 "../src/Services/MonitoredRepository.vala"
						_g_object_unref0 (branch_ref);
#line 161 "../src/Services/MonitoredRepository.vala"
						_ggit_branch_enumerator_unref0 (branch_enumerator);
#line 627 "MonitoredRepository.c"
						goto __catch0_g_error;
					}
#line 161 "../src/Services/MonitoredRepository.vala"
					_tmp11_ = g_strdup (_tmp8_);
#line 161 "../src/Services/MonitoredRepository.vala"
					branches = g_list_append (branches, _tmp11_);
#line 634 "MonitoredRepository.c"
				}
#line 159 "../src/Services/MonitoredRepository.vala"
				_g_object_unref0 (branch_ref);
#line 638 "MonitoredRepository.c"
			}
		}
#line 157 "../src/Services/MonitoredRepository.vala"
		_ggit_branch_enumerator_unref0 (branch_enumerator);
#line 643 "MonitoredRepository.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 157 "../src/Services/MonitoredRepository.vala"
		e = _inner_error0_;
#line 157 "../src/Services/MonitoredRepository.vala"
		_inner_error0_ = NULL;
#line 165 "../src/Services/MonitoredRepository.vala"
		_tmp12_ = e;
#line 165 "../src/Services/MonitoredRepository.vala"
		_tmp13_ = _tmp12_->message;
#line 165 "../src/Services/MonitoredRepository.vala"
		g_warning ("MonitoredRepository.vala:165: Could not enumerate branches %s", _tmp13_);
#line 157 "../src/Services/MonitoredRepository.vala"
		_g_error_free0 (e);
#line 663 "MonitoredRepository.c"
	}
	__finally0:
#line 157 "../src/Services/MonitoredRepository.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 157 "../src/Services/MonitoredRepository.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 157 "../src/Services/MonitoredRepository.vala"
		g_clear_error (&_inner_error0_);
#line 157 "../src/Services/MonitoredRepository.vala"
		return NULL;
#line 674 "MonitoredRepository.c"
	}
#line 168 "../src/Services/MonitoredRepository.vala"
	_tmp14_ = branches;
#line 168 "../src/Services/MonitoredRepository.vala"
	result = _tmp14_;
#line 168 "../src/Services/MonitoredRepository.vala"
	return result;
#line 682 "MonitoredRepository.c"
}

gboolean
scratch_services_monitored_repository_has_local_branch_name (ScratchServicesMonitoredRepository* self,
                                                             const gchar* name)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 171 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 695 "MonitoredRepository.c"
	{
		GgitRepository* _tmp0_;
		GgitBranch* _tmp1_;
		GgitBranch* _tmp2_;
#line 173 "../src/Services/MonitoredRepository.vala"
		_tmp0_ = self->priv->_git_repo;
#line 173 "../src/Services/MonitoredRepository.vala"
		_tmp1_ = ggit_repository_lookup_branch (_tmp0_, name, GGIT_BRANCH_LOCAL, &_inner_error0_);
#line 173 "../src/Services/MonitoredRepository.vala"
		_tmp2_ = _tmp1_;
#line 173 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (_tmp2_);
#line 173 "../src/Services/MonitoredRepository.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 710 "MonitoredRepository.c"
			goto __catch0_g_error;
		}
#line 174 "../src/Services/MonitoredRepository.vala"
		result = TRUE;
#line 174 "../src/Services/MonitoredRepository.vala"
		return result;
#line 717 "MonitoredRepository.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 172 "../src/Services/MonitoredRepository.vala"
		g_clear_error (&_inner_error0_);
#line 724 "MonitoredRepository.c"
	}
	__finally0:
#line 172 "../src/Services/MonitoredRepository.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 729 "MonitoredRepository.c"
		gboolean _tmp3_ = FALSE;
#line 172 "../src/Services/MonitoredRepository.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 172 "../src/Services/MonitoredRepository.vala"
		g_clear_error (&_inner_error0_);
#line 172 "../src/Services/MonitoredRepository.vala"
		return _tmp3_;
#line 737 "MonitoredRepository.c"
	}
#line 177 "../src/Services/MonitoredRepository.vala"
	result = FALSE;
#line 177 "../src/Services/MonitoredRepository.vala"
	return result;
#line 743 "MonitoredRepository.c"
}

gboolean
scratch_services_monitored_repository_is_valid_new_local_branch_name (ScratchServicesMonitoredRepository* self,
                                                                      const gchar* new_name)
{
	gboolean _tmp0_ = FALSE;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 180 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 180 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (new_name != NULL, FALSE);
#line 181 "../src/Services/MonitoredRepository.vala"
	_tmp1_ = g_strconcat ("refs/heads/", new_name, NULL);
#line 181 "../src/Services/MonitoredRepository.vala"
	_tmp2_ = _tmp1_;
#line 181 "../src/Services/MonitoredRepository.vala"
	_tmp3_ = !ggit_ref_is_valid_name (_tmp2_);
#line 181 "../src/Services/MonitoredRepository.vala"
	_g_free0 (_tmp2_);
#line 181 "../src/Services/MonitoredRepository.vala"
	if (_tmp3_) {
#line 181 "../src/Services/MonitoredRepository.vala"
		_tmp0_ = TRUE;
#line 771 "MonitoredRepository.c"
	} else {
#line 182 "../src/Services/MonitoredRepository.vala"
		_tmp0_ = scratch_services_monitored_repository_has_local_branch_name (self, new_name);
#line 775 "MonitoredRepository.c"
	}
#line 181 "../src/Services/MonitoredRepository.vala"
	if (_tmp0_) {
#line 183 "../src/Services/MonitoredRepository.vala"
		result = FALSE;
#line 183 "../src/Services/MonitoredRepository.vala"
		return result;
#line 783 "MonitoredRepository.c"
	}
#line 186 "../src/Services/MonitoredRepository.vala"
	result = TRUE;
#line 186 "../src/Services/MonitoredRepository.vala"
	return result;
#line 789 "MonitoredRepository.c"
}

void
scratch_services_monitored_repository_change_branch (ScratchServicesMonitoredRepository* self,
                                                     const gchar* new_branch_name,
                                                     GError** error)
{
	GgitBranch* branch = NULL;
	GgitRepository* _tmp0_;
	GgitBranch* _tmp1_;
	GgitRepository* _tmp2_;
	GgitBranch* _tmp3_;
	const gchar* _tmp4_;
	GgitCheckoutOptions* options = NULL;
	GgitCheckoutOptions* _tmp5_ = NULL;
	GgitRepository* _tmp6_;
	GgitCheckoutOptions* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 189 "../src/Services/MonitoredRepository.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/Services/MonitoredRepository.vala"
	g_return_if_fail (new_branch_name != NULL);
#line 190 "../src/Services/MonitoredRepository.vala"
	_tmp0_ = self->priv->_git_repo;
#line 190 "../src/Services/MonitoredRepository.vala"
	_tmp1_ = ggit_repository_lookup_branch (_tmp0_, new_branch_name, GGIT_BRANCH_LOCAL, &_inner_error0_);
#line 190 "../src/Services/MonitoredRepository.vala"
	branch = _tmp1_;
#line 190 "../src/Services/MonitoredRepository.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 190 "../src/Services/MonitoredRepository.vala"
		g_propagate_error (error, _inner_error0_);
#line 190 "../src/Services/MonitoredRepository.vala"
		return;
#line 824 "MonitoredRepository.c"
	}
#line 191 "../src/Services/MonitoredRepository.vala"
	_tmp2_ = self->priv->_git_repo;
#line 191 "../src/Services/MonitoredRepository.vala"
	_tmp3_ = branch;
#line 191 "../src/Services/MonitoredRepository.vala"
	_tmp4_ = ggit_ref_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, ggit_ref_get_type (), GgitRef));
#line 191 "../src/Services/MonitoredRepository.vala"
	ggit_repository_set_head (_tmp2_, _tmp4_, &_inner_error0_);
#line 191 "../src/Services/MonitoredRepository.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 191 "../src/Services/MonitoredRepository.vala"
		g_propagate_error (error, _inner_error0_);
#line 191 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (branch);
#line 191 "../src/Services/MonitoredRepository.vala"
		return;
#line 842 "MonitoredRepository.c"
	}
#line 192 "../src/Services/MonitoredRepository.vala"
	_tmp5_ = ggit_checkout_options_new ();
#line 192 "../src/Services/MonitoredRepository.vala"
	ggit_checkout_options_set_strategy (_tmp5_, GGIT_CHECKOUT_FORCE);
#line 192 "../src/Services/MonitoredRepository.vala"
	options = _tmp5_;
#line 197 "../src/Services/MonitoredRepository.vala"
	_tmp6_ = self->priv->_git_repo;
#line 197 "../src/Services/MonitoredRepository.vala"
	_tmp7_ = options;
#line 197 "../src/Services/MonitoredRepository.vala"
	ggit_repository_checkout_head (_tmp6_, _tmp7_, &_inner_error0_);
#line 197 "../src/Services/MonitoredRepository.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../src/Services/MonitoredRepository.vala"
		g_propagate_error (error, _inner_error0_);
#line 197 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (options);
#line 197 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (branch);
#line 197 "../src/Services/MonitoredRepository.vala"
		return;
#line 866 "MonitoredRepository.c"
	}
#line 199 "../src/Services/MonitoredRepository.vala"
	scratch_services_monitored_repository_set_branch_name (self, new_branch_name);
#line 189 "../src/Services/MonitoredRepository.vala"
	_g_object_unref0 (options);
#line 189 "../src/Services/MonitoredRepository.vala"
	_g_object_unref0 (branch);
#line 874 "MonitoredRepository.c"
}

void
scratch_services_monitored_repository_create_new_branch (ScratchServicesMonitoredRepository* self,
                                                         const gchar* name,
                                                         GError** error)
{
	GgitRef* _tmp0_ = NULL;
	GgitRepository* _tmp1_;
	GgitRef* _tmp2_;
	GgitObject* git_object = NULL;
	GgitObject* _tmp3_;
	GgitBranch* new_branch = NULL;
	GgitRepository* _tmp4_;
	GgitObject* _tmp5_;
	GgitBranch* _tmp6_;
	GgitRepository* _tmp7_;
	GgitBranch* _tmp8_;
	const gchar* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 202 "../src/Services/MonitoredRepository.vala"
	g_return_if_fail (self != NULL);
#line 202 "../src/Services/MonitoredRepository.vala"
	g_return_if_fail (name != NULL);
#line 203 "../src/Services/MonitoredRepository.vala"
	_tmp1_ = self->priv->_git_repo;
#line 203 "../src/Services/MonitoredRepository.vala"
	_tmp2_ = ggit_repository_get_head (_tmp1_, &_inner_error0_);
#line 203 "../src/Services/MonitoredRepository.vala"
	_tmp0_ = _tmp2_;
#line 203 "../src/Services/MonitoredRepository.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 203 "../src/Services/MonitoredRepository.vala"
		g_propagate_error (error, _inner_error0_);
#line 203 "../src/Services/MonitoredRepository.vala"
		return;
#line 911 "MonitoredRepository.c"
	}
#line 203 "../src/Services/MonitoredRepository.vala"
	_tmp3_ = ggit_ref_lookup (_tmp0_, &_inner_error0_);
#line 203 "../src/Services/MonitoredRepository.vala"
	git_object = _tmp3_;
#line 203 "../src/Services/MonitoredRepository.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 203 "../src/Services/MonitoredRepository.vala"
		g_propagate_error (error, _inner_error0_);
#line 203 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (_tmp0_);
#line 203 "../src/Services/MonitoredRepository.vala"
		return;
#line 925 "MonitoredRepository.c"
	}
#line 204 "../src/Services/MonitoredRepository.vala"
	_tmp4_ = self->priv->_git_repo;
#line 204 "../src/Services/MonitoredRepository.vala"
	_tmp5_ = git_object;
#line 204 "../src/Services/MonitoredRepository.vala"
	_tmp6_ = ggit_repository_create_branch (_tmp4_, name, _tmp5_, GGIT_CREATE_NONE, &_inner_error0_);
#line 204 "../src/Services/MonitoredRepository.vala"
	new_branch = _tmp6_;
#line 204 "../src/Services/MonitoredRepository.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 204 "../src/Services/MonitoredRepository.vala"
		g_propagate_error (error, _inner_error0_);
#line 204 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (git_object);
#line 204 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (_tmp0_);
#line 204 "../src/Services/MonitoredRepository.vala"
		return;
#line 945 "MonitoredRepository.c"
	}
#line 205 "../src/Services/MonitoredRepository.vala"
	_tmp7_ = self->priv->_git_repo;
#line 205 "../src/Services/MonitoredRepository.vala"
	_tmp8_ = new_branch;
#line 205 "../src/Services/MonitoredRepository.vala"
	_tmp9_ = ggit_ref_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, ggit_ref_get_type (), GgitRef));
#line 205 "../src/Services/MonitoredRepository.vala"
	ggit_repository_set_head (_tmp7_, _tmp9_, &_inner_error0_);
#line 205 "../src/Services/MonitoredRepository.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 205 "../src/Services/MonitoredRepository.vala"
		g_propagate_error (error, _inner_error0_);
#line 205 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (new_branch);
#line 205 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (git_object);
#line 205 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (_tmp0_);
#line 205 "../src/Services/MonitoredRepository.vala"
		return;
#line 967 "MonitoredRepository.c"
	}
#line 202 "../src/Services/MonitoredRepository.vala"
	_g_object_unref0 (new_branch);
#line 202 "../src/Services/MonitoredRepository.vala"
	_g_object_unref0 (git_object);
#line 202 "../src/Services/MonitoredRepository.vala"
	_g_object_unref0 (_tmp0_);
#line 975 "MonitoredRepository.c"
}

static void
_vala_GgitOId_free (GgitOId* self)
{
#line 216 "../src/Services/MonitoredRepository.vala"
	g_boxed_free (ggit_oid_get_type (), self);
#line 983 "MonitoredRepository.c"
}

static gint
____lambda6_ (ScratchServicesMonitoredRepository* self,
              const gchar* path,
              GgitStatusFlags status)
{
	GeeHashMap* _tmp0_;
	gint result;
#line 238 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (path != NULL, 0);
#line 239 "../src/Services/MonitoredRepository.vala"
	_tmp0_ = self->priv->file_status_map;
#line 239 "../src/Services/MonitoredRepository.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, path, (gpointer) ((gintptr) (&status)));
#line 240 "../src/Services/MonitoredRepository.vala"
	result = 0;
#line 240 "../src/Services/MonitoredRepository.vala"
	return result;
#line 1003 "MonitoredRepository.c"
}

static gint
_____lambda6__ggit_status_callback (const gchar* path,
                                    GgitStatusFlags status_flags,
                                    gpointer self)
{
	gint result;
	result = ____lambda6_ ((ScratchServicesMonitoredRepository*) self, path, status_flags);
#line 238 "../src/Services/MonitoredRepository.vala"
	return result;
#line 1015 "MonitoredRepository.c"
}

static gboolean
___lambda5_ (ScratchServicesMonitoredRepository* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 212 "../src/Services/MonitoredRepository.vala"
	if (self->priv->do_update) {
#line 1025 "MonitoredRepository.c"
		gchar* target_name = NULL;
		gchar* _tmp0_;
		const gchar* _tmp18_;
#line 213 "../src/Services/MonitoredRepository.vala"
		_tmp0_ = g_strdup ("");
#line 213 "../src/Services/MonitoredRepository.vala"
		target_name = _tmp0_;
#line 1033 "MonitoredRepository.c"
		{
			GgitRef* head = NULL;
			GgitRepository* _tmp1_;
			GgitRef* _tmp2_;
			GgitRef* _tmp3_;
#line 215 "../src/Services/MonitoredRepository.vala"
			_tmp1_ = self->priv->_git_repo;
#line 215 "../src/Services/MonitoredRepository.vala"
			_tmp2_ = ggit_repository_get_head (_tmp1_, &_inner_error0_);
#line 215 "../src/Services/MonitoredRepository.vala"
			head = _tmp2_;
#line 215 "../src/Services/MonitoredRepository.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1047 "MonitoredRepository.c"
				goto __catch0_g_error;
			}
#line 216 "../src/Services/MonitoredRepository.vala"
			_tmp3_ = head;
#line 216 "../src/Services/MonitoredRepository.vala"
			if (ggit_ref_is_branch (_tmp3_)) {
#line 1054 "MonitoredRepository.c"
				const gchar* _tmp4_ = NULL;
				GgitRef* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
#line 217 "../src/Services/MonitoredRepository.vala"
				_tmp5_ = head;
#line 217 "../src/Services/MonitoredRepository.vala"
				_tmp6_ = ggit_branch_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, ggit_branch_get_type (), GgitBranch), &_inner_error0_);
#line 217 "../src/Services/MonitoredRepository.vala"
				_tmp4_ = _tmp6_;
#line 217 "../src/Services/MonitoredRepository.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 217 "../src/Services/MonitoredRepository.vala"
					_g_object_unref0 (head);
#line 1069 "MonitoredRepository.c"
					goto __catch0_g_error;
				}
#line 217 "../src/Services/MonitoredRepository.vala"
				_tmp7_ = g_strdup (_tmp4_);
#line 217 "../src/Services/MonitoredRepository.vala"
				_g_free0 (target_name);
#line 217 "../src/Services/MonitoredRepository.vala"
				target_name = _tmp7_;
#line 1078 "MonitoredRepository.c"
			} else {
				GgitOId* target = NULL;
				GgitRef* _tmp8_;
				GgitOId* _tmp9_;
				GgitOId* _tmp10_;
#line 219 "../src/Services/MonitoredRepository.vala"
				_tmp8_ = head;
#line 219 "../src/Services/MonitoredRepository.vala"
				_tmp9_ = ggit_ref_get_target (_tmp8_);
#line 219 "../src/Services/MonitoredRepository.vala"
				target = _tmp9_;
#line 220 "../src/Services/MonitoredRepository.vala"
				_tmp10_ = target;
#line 220 "../src/Services/MonitoredRepository.vala"
				if (_tmp10_ != NULL) {
#line 1094 "MonitoredRepository.c"
					GgitOId* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
#line 222 "../src/Services/MonitoredRepository.vala"
					_tmp11_ = target;
#line 222 "../src/Services/MonitoredRepository.vala"
					_tmp12_ = ggit_oid_to_string (_tmp11_);
#line 222 "../src/Services/MonitoredRepository.vala"
					_tmp13_ = _tmp12_;
#line 222 "../src/Services/MonitoredRepository.vala"
					_tmp14_ = g_strdup_printf (_ ("%.8s (detached)"), _tmp13_);
#line 222 "../src/Services/MonitoredRepository.vala"
					_g_free0 (target_name);
#line 222 "../src/Services/MonitoredRepository.vala"
					target_name = _tmp14_;
#line 222 "../src/Services/MonitoredRepository.vala"
					_g_free0 (_tmp13_);
#line 1113 "MonitoredRepository.c"
				}
#line 216 "../src/Services/MonitoredRepository.vala"
				__vala_GgitOId_free0 (target);
#line 1117 "MonitoredRepository.c"
			}
#line 214 "../src/Services/MonitoredRepository.vala"
			_g_object_unref0 (head);
#line 1121 "MonitoredRepository.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp15_;
			const gchar* _tmp16_;
#line 214 "../src/Services/MonitoredRepository.vala"
			e = _inner_error0_;
#line 214 "../src/Services/MonitoredRepository.vala"
			_inner_error0_ = NULL;
#line 227 "../src/Services/MonitoredRepository.vala"
			_tmp15_ = e;
#line 227 "../src/Services/MonitoredRepository.vala"
			_tmp16_ = _tmp15_->message;
#line 227 "../src/Services/MonitoredRepository.vala"
			g_warning ("MonitoredRepository.vala:227: An error occurred while fetching the cur" \
"rent git branch name: %s", _tmp16_);
#line 214 "../src/Services/MonitoredRepository.vala"
			_g_error_free0 (e);
#line 1141 "MonitoredRepository.c"
		}
		__finally0:
#line 214 "../src/Services/MonitoredRepository.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1146 "MonitoredRepository.c"
			gboolean _tmp17_ = FALSE;
#line 214 "../src/Services/MonitoredRepository.vala"
			_g_free0 (target_name);
#line 214 "../src/Services/MonitoredRepository.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 214 "../src/Services/MonitoredRepository.vala"
			g_clear_error (&_inner_error0_);
#line 214 "../src/Services/MonitoredRepository.vala"
			return _tmp17_;
#line 1156 "MonitoredRepository.c"
		}
#line 230 "../src/Services/MonitoredRepository.vala"
		_tmp18_ = target_name;
#line 230 "../src/Services/MonitoredRepository.vala"
		scratch_services_monitored_repository_set_branch_name (self, _tmp18_);
#line 1162 "MonitoredRepository.c"
		{
			GeeHashMap* _tmp19_;
			GgitRepository* _tmp20_;
			GgitStatusOptions* _tmp21_;
#line 236 "../src/Services/MonitoredRepository.vala"
			_tmp19_ = self->priv->file_status_map;
#line 236 "../src/Services/MonitoredRepository.vala"
			gee_abstract_map_clear ((GeeAbstractMap*) _tmp19_);
#line 238 "../src/Services/MonitoredRepository.vala"
			_tmp20_ = self->priv->_git_repo;
#line 238 "../src/Services/MonitoredRepository.vala"
			_tmp21_ = self->priv->status_options;
#line 238 "../src/Services/MonitoredRepository.vala"
			ggit_repository_file_status_foreach (_tmp20_, _tmp21_, _____lambda6__ggit_status_callback, self, &_inner_error0_);
#line 238 "../src/Services/MonitoredRepository.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1179 "MonitoredRepository.c"
				goto __catch1_g_error;
			}
#line 243 "../src/Services/MonitoredRepository.vala"
			g_signal_emit (self, scratch_services_monitored_repository_signals[SCRATCH_SERVICES_MONITORED_REPOSITORY_FILE_STATUS_CHANGE_SIGNAL], 0);
#line 1184 "MonitoredRepository.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp22_;
			const gchar* _tmp23_;
#line 235 "../src/Services/MonitoredRepository.vala"
			e = _inner_error0_;
#line 235 "../src/Services/MonitoredRepository.vala"
			_inner_error0_ = NULL;
#line 245 "../src/Services/MonitoredRepository.vala"
			_tmp22_ = e;
#line 245 "../src/Services/MonitoredRepository.vala"
			_tmp23_ = _tmp22_->message;
#line 245 "../src/Services/MonitoredRepository.vala"
			g_critical ("MonitoredRepository.vala:245: Error enumerating git status: %s", _tmp23_);
#line 235 "../src/Services/MonitoredRepository.vala"
			_g_error_free0 (e);
#line 1204 "MonitoredRepository.c"
		}
		__finally1:
#line 235 "../src/Services/MonitoredRepository.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1209 "MonitoredRepository.c"
			gboolean _tmp24_ = FALSE;
#line 235 "../src/Services/MonitoredRepository.vala"
			_g_free0 (target_name);
#line 235 "../src/Services/MonitoredRepository.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 235 "../src/Services/MonitoredRepository.vala"
			g_clear_error (&_inner_error0_);
#line 235 "../src/Services/MonitoredRepository.vala"
			return _tmp24_;
#line 1219 "MonitoredRepository.c"
		}
#line 248 "../src/Services/MonitoredRepository.vala"
		self->priv->do_update = FALSE;
#line 249 "../src/Services/MonitoredRepository.vala"
		self->priv->update_timer_id = (guint) 0;
#line 250 "../src/Services/MonitoredRepository.vala"
		result = G_SOURCE_REMOVE;
#line 250 "../src/Services/MonitoredRepository.vala"
		_g_free0 (target_name);
#line 250 "../src/Services/MonitoredRepository.vala"
		return result;
#line 1231 "MonitoredRepository.c"
	} else {
#line 252 "../src/Services/MonitoredRepository.vala"
		self->priv->do_update = TRUE;
#line 253 "../src/Services/MonitoredRepository.vala"
		result = G_SOURCE_CONTINUE;
#line 253 "../src/Services/MonitoredRepository.vala"
		return result;
#line 1239 "MonitoredRepository.c"
	}
}

static gboolean
____lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda5_ ((ScratchServicesMonitoredRepository*) self);
#line 211 "../src/Services/MonitoredRepository.vala"
	return result;
#line 1250 "MonitoredRepository.c"
}

void
scratch_services_monitored_repository_update_status_map (ScratchServicesMonitoredRepository* self)
{
#line 209 "../src/Services/MonitoredRepository.vala"
	g_return_if_fail (self != NULL);
#line 210 "../src/Services/MonitoredRepository.vala"
	if (self->priv->update_timer_id == ((guint) 0)) {
#line 211 "../src/Services/MonitoredRepository.vala"
		self->priv->update_timer_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 150, ____lambda5__gsource_func, g_object_ref (self), g_object_unref);
#line 257 "../src/Services/MonitoredRepository.vala"
		g_signal_emit (self, scratch_services_monitored_repository_signals[SCRATCH_SERVICES_MONITORED_REPOSITORY_FILE_CONTENT_CHANGED_SIGNAL], 0);
#line 1264 "MonitoredRepository.c"
	} else {
#line 259 "../src/Services/MonitoredRepository.vala"
		self->priv->do_update = FALSE;
#line 1268 "MonitoredRepository.c"
	}
}

gboolean
scratch_services_monitored_repository_path_is_ignored (ScratchServicesMonitoredRepository* self,
                                                       const gchar* path,
                                                       GError** error)
{
	gboolean _tmp0_ = FALSE;
	GgitRepository* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 263 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 263 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 264 "../src/Services/MonitoredRepository.vala"
	_tmp1_ = self->priv->_git_repo;
#line 264 "../src/Services/MonitoredRepository.vala"
	_tmp0_ = ggit_repository_path_is_ignored (_tmp1_, path, &_inner_error0_);
#line 264 "../src/Services/MonitoredRepository.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1291 "MonitoredRepository.c"
		gboolean _tmp2_ = FALSE;
#line 264 "../src/Services/MonitoredRepository.vala"
		g_propagate_error (error, _inner_error0_);
#line 264 "../src/Services/MonitoredRepository.vala"
		return _tmp2_;
#line 1297 "MonitoredRepository.c"
	}
#line 264 "../src/Services/MonitoredRepository.vala"
	result = _tmp0_;
#line 264 "../src/Services/MonitoredRepository.vala"
	return result;
#line 1303 "MonitoredRepository.c"
}

static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
#line 268 "../src/Services/MonitoredRepository.vala"
	g_atomic_int_inc (&_data23_->_ref_count_);
#line 268 "../src/Services/MonitoredRepository.vala"
	return _data23_;
#line 1313 "MonitoredRepository.c"
}

static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
#line 268 "../src/Services/MonitoredRepository.vala"
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
#line 1323 "MonitoredRepository.c"
		ScratchServicesMonitoredRepository* self;
#line 268 "../src/Services/MonitoredRepository.vala"
		self = _data23_->self;
#line 268 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (_data23_->status_map);
#line 268 "../src/Services/MonitoredRepository.vala"
		_g_free0 (_data23_->file_path);
#line 268 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (self);
#line 268 "../src/Services/MonitoredRepository.vala"
		g_slice_free (Block23Data, _data23_);
#line 1335 "MonitoredRepository.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 277 "../src/Services/MonitoredRepository.vala"
	return self ? g_object_ref (self) : NULL;
#line 1344 "MonitoredRepository.c"
}

static gint
___lambda8_ (Block23Data* _data23_,
             GgitDiffDelta* delta,
             GgitDiffHunk* hunk,
             GgitDiffLine* line)
{
	ScratchServicesMonitoredRepository* self;
	GgitDiffFile* file_diff = NULL;
	GgitDiffFile* _tmp0_;
	GgitDiffFile* _tmp1_;
	const gchar* diff_file_path = NULL;
	GgitDiffFile* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	gint result;
#line 284 "../src/Services/MonitoredRepository.vala"
	self = _data23_->self;
#line 284 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (delta != NULL, 0);
#line 284 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (hunk != NULL, 0);
#line 284 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (line != NULL, 0);
#line 285 "../src/Services/MonitoredRepository.vala"
	_tmp0_ = ggit_diff_delta_get_old_file (delta);
#line 285 "../src/Services/MonitoredRepository.vala"
	file_diff = _tmp0_;
#line 286 "../src/Services/MonitoredRepository.vala"
	_tmp1_ = file_diff;
#line 286 "../src/Services/MonitoredRepository.vala"
	if (_tmp1_ == NULL) {
#line 287 "../src/Services/MonitoredRepository.vala"
		result = 0;
#line 287 "../src/Services/MonitoredRepository.vala"
		return result;
#line 1383 "MonitoredRepository.c"
	}
#line 290 "../src/Services/MonitoredRepository.vala"
	_tmp2_ = file_diff;
#line 290 "../src/Services/MonitoredRepository.vala"
	_tmp3_ = ggit_diff_file_get_path (_tmp2_);
#line 290 "../src/Services/MonitoredRepository.vala"
	diff_file_path = _tmp3_;
#line 292 "../src/Services/MonitoredRepository.vala"
	_tmp5_ = diff_file_path;
#line 292 "../src/Services/MonitoredRepository.vala"
	if (_tmp5_ == NULL) {
#line 292 "../src/Services/MonitoredRepository.vala"
		_tmp4_ = TRUE;
#line 1397 "MonitoredRepository.c"
	} else {
		const gchar* _tmp6_;
#line 293 "../src/Services/MonitoredRepository.vala"
		_tmp6_ = diff_file_path;
#line 293 "../src/Services/MonitoredRepository.vala"
		_tmp4_ = !g_str_has_suffix (_data23_->file_path, _tmp6_);
#line 1404 "MonitoredRepository.c"
	}
#line 292 "../src/Services/MonitoredRepository.vala"
	if (_tmp4_) {
#line 295 "../src/Services/MonitoredRepository.vala"
		result = 0;
#line 295 "../src/Services/MonitoredRepository.vala"
		return result;
#line 1412 "MonitoredRepository.c"
	}
#line 298 "../src/Services/MonitoredRepository.vala"
	scratch_services_monitored_repository_process_diff_line (self, ggit_diff_line_get_origin (line), ggit_diff_line_get_new_lineno (line), ggit_diff_line_get_old_lineno (line), &_data23_->status_map, &_data23_->prev_deletions, &_data23_->prev_additions);
#line 306 "../src/Services/MonitoredRepository.vala"
	result = 0;
#line 306 "../src/Services/MonitoredRepository.vala"
	return result;
#line 1420 "MonitoredRepository.c"
}

static gint
____lambda8__ggit_diff_line_callback (GgitDiffDelta* delta,
                                      GgitDiffHunk* hunk,
                                      GgitDiffLine* line,
                                      gpointer self)
{
	gint result;
	result = ___lambda8_ (self, delta, hunk, line);
#line 283 "../src/Services/MonitoredRepository.vala"
	return result;
#line 1433 "MonitoredRepository.c"
}

void
scratch_services_monitored_repository_refresh_diff (ScratchServicesMonitoredRepository* self,
                                                    const gchar* file_path,
                                                    GeeHashMap** line_status_map)
{
	Block23Data* _data23_;
	gchar* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp7_;
	GeeHashMap* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 268 "../src/Services/MonitoredRepository.vala"
	g_return_if_fail (self != NULL);
#line 268 "../src/Services/MonitoredRepository.vala"
	g_return_if_fail (file_path != NULL);
#line 268 "../src/Services/MonitoredRepository.vala"
	g_return_if_fail (*line_status_map != NULL);
#line 268 "../src/Services/MonitoredRepository.vala"
	_data23_ = g_slice_new0 (Block23Data);
#line 268 "../src/Services/MonitoredRepository.vala"
	_data23_->_ref_count_ = 1;
#line 268 "../src/Services/MonitoredRepository.vala"
	_data23_->self = g_object_ref (self);
#line 268 "../src/Services/MonitoredRepository.vala"
	_tmp0_ = g_strdup (file_path);
#line 268 "../src/Services/MonitoredRepository.vala"
	_g_free0 (_data23_->file_path);
#line 268 "../src/Services/MonitoredRepository.vala"
	_data23_->file_path = _tmp0_;
#line 269 "../src/Services/MonitoredRepository.vala"
	if (self->priv->refreshing) {
#line 270 "../src/Services/MonitoredRepository.vala"
		block23_data_unref (_data23_);
#line 270 "../src/Services/MonitoredRepository.vala"
		_data23_ = NULL;
#line 270 "../src/Services/MonitoredRepository.vala"
		return;
#line 1473 "MonitoredRepository.c"
	} else {
#line 272 "../src/Services/MonitoredRepository.vala"
		self->priv->refreshing = TRUE;
#line 1477 "MonitoredRepository.c"
	}
#line 277 "../src/Services/MonitoredRepository.vala"
	_tmp1_ = _g_object_ref0 (*line_status_map);
#line 277 "../src/Services/MonitoredRepository.vala"
	_data23_->status_map = _tmp1_;
#line 279 "../src/Services/MonitoredRepository.vala"
	_data23_->prev_deletions = 0;
#line 280 "../src/Services/MonitoredRepository.vala"
	_data23_->prev_additions = 0;
#line 1487 "MonitoredRepository.c"
	{
		GgitDiff* repo_diff_list = NULL;
		GgitRepository* _tmp2_;
		GgitDiff* _tmp3_;
		GgitDiff* _tmp4_;
#line 282 "../src/Services/MonitoredRepository.vala"
		_tmp2_ = self->priv->_git_repo;
#line 282 "../src/Services/MonitoredRepository.vala"
		_tmp3_ = ggit_diff_new_index_to_workdir (_tmp2_, NULL, NULL, &_inner_error0_);
#line 282 "../src/Services/MonitoredRepository.vala"
		repo_diff_list = _tmp3_;
#line 282 "../src/Services/MonitoredRepository.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1501 "MonitoredRepository.c"
			goto __catch0_g_error;
		}
#line 283 "../src/Services/MonitoredRepository.vala"
		_tmp4_ = repo_diff_list;
#line 283 "../src/Services/MonitoredRepository.vala"
		ggit_diff_foreach (_tmp4_, NULL, NULL, NULL, ____lambda8__ggit_diff_line_callback, _data23_, &_inner_error0_);
#line 283 "../src/Services/MonitoredRepository.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 283 "../src/Services/MonitoredRepository.vala"
			_g_object_unref0 (repo_diff_list);
#line 1512 "MonitoredRepository.c"
			goto __catch0_g_error;
		}
#line 281 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (repo_diff_list);
#line 1517 "MonitoredRepository.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 281 "../src/Services/MonitoredRepository.vala"
		e = _inner_error0_;
#line 281 "../src/Services/MonitoredRepository.vala"
		_inner_error0_ = NULL;
#line 310 "../src/Services/MonitoredRepository.vala"
		_tmp5_ = e;
#line 310 "../src/Services/MonitoredRepository.vala"
		_tmp6_ = _tmp5_->message;
#line 310 "../src/Services/MonitoredRepository.vala"
		g_critical ("MonitoredRepository.vala:310: Error getting diff list %s", _tmp6_);
#line 281 "../src/Services/MonitoredRepository.vala"
		_g_error_free0 (e);
#line 1537 "MonitoredRepository.c"
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
#line 312 "../src/Services/MonitoredRepository.vala"
		self->priv->refreshing = FALSE;
#line 1544 "MonitoredRepository.c"
	}
#line 281 "../src/Services/MonitoredRepository.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 281 "../src/Services/MonitoredRepository.vala"
		block23_data_unref (_data23_);
#line 281 "../src/Services/MonitoredRepository.vala"
		_data23_ = NULL;
#line 281 "../src/Services/MonitoredRepository.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 281 "../src/Services/MonitoredRepository.vala"
		g_clear_error (&_inner_error0_);
#line 281 "../src/Services/MonitoredRepository.vala"
		return;
#line 1558 "MonitoredRepository.c"
	}
#line 315 "../src/Services/MonitoredRepository.vala"
	_tmp7_ = _data23_->status_map;
#line 315 "../src/Services/MonitoredRepository.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 315 "../src/Services/MonitoredRepository.vala"
	_g_object_unref0 (*line_status_map);
#line 315 "../src/Services/MonitoredRepository.vala"
	*line_status_map = _tmp8_;
#line 268 "../src/Services/MonitoredRepository.vala"
	block23_data_unref (_data23_);
#line 268 "../src/Services/MonitoredRepository.vala"
	_data23_ = NULL;
#line 1572 "MonitoredRepository.c"
}

static void
scratch_services_monitored_repository_process_diff_line (ScratchServicesMonitoredRepository* self,
                                                         GgitDiffLineType line_type,
                                                         gint new_line_no,
                                                         gint old_line_no,
                                                         GeeHashMap** line_status_map,
                                                         gint* prev_deletions,
                                                         gint* prev_additions)
{
#line 318 "../src/Services/MonitoredRepository.vala"
	g_return_if_fail (self != NULL);
#line 318 "../src/Services/MonitoredRepository.vala"
	g_return_if_fail (*line_status_map != NULL);
#line 323 "../src/Services/MonitoredRepository.vala"
	if (line_type == GGIT_DIFF_LINE_CONTEXT) {
#line 324 "../src/Services/MonitoredRepository.vala"
		if ((*prev_deletions) > 0) {
#line 325 "../src/Services/MonitoredRepository.vala"
			gee_abstract_map_set ((GeeAbstractMap*) (*line_status_map), (gpointer) ((gintptr) new_line_no), (gpointer) ((gintptr) SCRATCH_SERVICES_VC_STATUS_REPLACES_DELETED));
#line 1594 "MonitoredRepository.c"
		}
#line 328 "../src/Services/MonitoredRepository.vala"
		*prev_deletions = 0;
#line 329 "../src/Services/MonitoredRepository.vala"
		*prev_additions = 0;
#line 330 "../src/Services/MonitoredRepository.vala"
		return;
#line 1602 "MonitoredRepository.c"
	}
#line 333 "../src/Services/MonitoredRepository.vala"
	if (new_line_no < 0) {
#line 1606 "MonitoredRepository.c"
		gint _tmp0_;
#line 334 "../src/Services/MonitoredRepository.vala"
		_tmp0_ = *prev_deletions;
#line 334 "../src/Services/MonitoredRepository.vala"
		*prev_deletions = _tmp0_ + 1;
#line 335 "../src/Services/MonitoredRepository.vala"
		*prev_additions = 0;
#line 336 "../src/Services/MonitoredRepository.vala"
		return;
#line 1616 "MonitoredRepository.c"
	} else {
#line 338 "../src/Services/MonitoredRepository.vala"
		if (line_type == GGIT_DIFF_LINE_ADDITION) {
#line 1620 "MonitoredRepository.c"
			gint _tmp1_;
#line 339 "../src/Services/MonitoredRepository.vala"
			_tmp1_ = *prev_additions;
#line 339 "../src/Services/MonitoredRepository.vala"
			*prev_additions = _tmp1_ + 1;
#line 340 "../src/Services/MonitoredRepository.vala"
			if ((*prev_deletions) >= (*prev_additions)) {
#line 1628 "MonitoredRepository.c"
				gint _tmp2_;
#line 341 "../src/Services/MonitoredRepository.vala"
				gee_abstract_map_set ((GeeAbstractMap*) (*line_status_map), (gpointer) ((gintptr) new_line_no), (gpointer) ((gintptr) SCRATCH_SERVICES_VC_STATUS_CHANGED));
#line 342 "../src/Services/MonitoredRepository.vala"
				_tmp2_ = *prev_deletions;
#line 342 "../src/Services/MonitoredRepository.vala"
				*prev_deletions = _tmp2_ - 1;
#line 1636 "MonitoredRepository.c"
			} else {
#line 344 "../src/Services/MonitoredRepository.vala"
				gee_abstract_map_set ((GeeAbstractMap*) (*line_status_map), (gpointer) ((gintptr) new_line_no), (gpointer) ((gintptr) SCRATCH_SERVICES_VC_STATUS_ADDED));
#line 345 "../src/Services/MonitoredRepository.vala"
				*prev_deletions = 0;
#line 1642 "MonitoredRepository.c"
			}
		} else {
#line 348 "../src/Services/MonitoredRepository.vala"
			gee_abstract_map_set ((GeeAbstractMap*) (*line_status_map), (gpointer) ((gintptr) new_line_no), (gpointer) ((gintptr) SCRATCH_SERVICES_VC_STATUS_OTHER));
#line 1647 "MonitoredRepository.c"
		}
	}
}

GgitRepository*
scratch_services_monitored_repository_get_git_repo (ScratchServicesMonitoredRepository* self)
{
	GgitRepository* result;
	GgitRepository* _tmp0_;
#line 32 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/Services/MonitoredRepository.vala"
	_tmp0_ = self->priv->_git_repo;
#line 32 "../src/Services/MonitoredRepository.vala"
	result = _tmp0_;
#line 32 "../src/Services/MonitoredRepository.vala"
	return result;
#line 1665 "MonitoredRepository.c"
}

void
scratch_services_monitored_repository_set_git_repo (ScratchServicesMonitoredRepository* self,
                                                    GgitRepository* value)
{
	GgitRepository* old_value;
#line 32 "../src/Services/MonitoredRepository.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Services/MonitoredRepository.vala"
	old_value = scratch_services_monitored_repository_get_git_repo (self);
#line 32 "../src/Services/MonitoredRepository.vala"
	if (old_value != value) {
#line 1679 "MonitoredRepository.c"
		GgitRepository* _tmp0_;
#line 32 "../src/Services/MonitoredRepository.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 32 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (self->priv->_git_repo);
#line 32 "../src/Services/MonitoredRepository.vala"
		self->priv->_git_repo = _tmp0_;
#line 32 "../src/Services/MonitoredRepository.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_services_monitored_repository_properties[SCRATCH_SERVICES_MONITORED_REPOSITORY_GIT_REPO_PROPERTY]);
#line 1689 "MonitoredRepository.c"
	}
}

const gchar*
scratch_services_monitored_repository_get_branch_name (ScratchServicesMonitoredRepository* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Services/MonitoredRepository.vala"
	_tmp0_ = self->priv->_branch_name;
#line 35 "../src/Services/MonitoredRepository.vala"
	result = _tmp0_;
#line 35 "../src/Services/MonitoredRepository.vala"
	return result;
#line 1706 "MonitoredRepository.c"
}

void
scratch_services_monitored_repository_set_branch_name (ScratchServicesMonitoredRepository* self,
                                                       const gchar* value)
{
	const gchar* _tmp0_;
#line 38 "../src/Services/MonitoredRepository.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Services/MonitoredRepository.vala"
	_tmp0_ = self->priv->_branch_name;
#line 39 "../src/Services/MonitoredRepository.vala"
	if (g_strcmp0 (_tmp0_, value) != 0) {
#line 1720 "MonitoredRepository.c"
		gchar* _tmp1_;
#line 40 "../src/Services/MonitoredRepository.vala"
		_tmp1_ = g_strdup (value);
#line 40 "../src/Services/MonitoredRepository.vala"
		_g_free0 (self->priv->_branch_name);
#line 40 "../src/Services/MonitoredRepository.vala"
		self->priv->_branch_name = _tmp1_;
#line 41 "../src/Services/MonitoredRepository.vala"
		g_signal_emit (self, scratch_services_monitored_repository_signals[SCRATCH_SERVICES_MONITORED_REPOSITORY_BRANCH_CHANGED_SIGNAL], 0);
#line 1730 "MonitoredRepository.c"
	}
#line 38 "../src/Services/MonitoredRepository.vala"
	g_object_notify_by_pspec ((GObject *) self, scratch_services_monitored_repository_properties[SCRATCH_SERVICES_MONITORED_REPOSITORY_BRANCH_NAME_PROPERTY]);
#line 1734 "MonitoredRepository.c"
}

gboolean
scratch_services_monitored_repository_get_head_is_branch (ScratchServicesMonitoredRepository* self)
{
	gboolean result;
	gboolean _tmp3_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 47 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1745 "MonitoredRepository.c"
	{
		GgitRef* _tmp0_ = NULL;
		GgitRepository* _tmp1_;
		GgitRef* _tmp2_;
#line 49 "../src/Services/MonitoredRepository.vala"
		_tmp1_ = self->priv->_git_repo;
#line 49 "../src/Services/MonitoredRepository.vala"
		_tmp2_ = ggit_repository_get_head (_tmp1_, &_inner_error0_);
#line 49 "../src/Services/MonitoredRepository.vala"
		_tmp0_ = _tmp2_;
#line 49 "../src/Services/MonitoredRepository.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1758 "MonitoredRepository.c"
			goto __catch0_g_error;
		}
#line 49 "../src/Services/MonitoredRepository.vala"
		result = ggit_ref_is_branch (_tmp0_);
#line 49 "../src/Services/MonitoredRepository.vala"
		_g_object_unref0 (_tmp0_);
#line 49 "../src/Services/MonitoredRepository.vala"
		return result;
#line 1767 "MonitoredRepository.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 48 "../src/Services/MonitoredRepository.vala"
		g_clear_error (&_inner_error0_);
#line 51 "../src/Services/MonitoredRepository.vala"
		result = FALSE;
#line 51 "../src/Services/MonitoredRepository.vala"
		return result;
#line 1778 "MonitoredRepository.c"
	}
	__finally0:
#line 48 "../src/Services/MonitoredRepository.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "../src/Services/MonitoredRepository.vala"
	g_clear_error (&_inner_error0_);
#line 48 "../src/Services/MonitoredRepository.vala"
	return _tmp3_;
#line 1787 "MonitoredRepository.c"
}

GeeSet*
scratch_services_monitored_repository_get_non_current_entries (ScratchServicesMonitoredRepository* self)
{
	GeeSet* result;
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
#line 71 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../src/Services/MonitoredRepository.vala"
	_tmp0_ = self->priv->file_status_map;
#line 72 "../src/Services/MonitoredRepository.vala"
	_tmp1_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp0_);
#line 72 "../src/Services/MonitoredRepository.vala"
	_tmp2_ = _tmp1_;
#line 72 "../src/Services/MonitoredRepository.vala"
	result = _tmp2_;
#line 72 "../src/Services/MonitoredRepository.vala"
	return result;
#line 1809 "MonitoredRepository.c"
}

static gboolean
_scratch_services_monitored_repository_has_uncommitted___lambda9_ (ScratchServicesMonitoredRepository* self,
                                                                   GgitStatusFlags* status)
{
	gboolean result;
#line 79 "../src/Services/MonitoredRepository.vala"
	switch (*status) {
#line 79 "../src/Services/MonitoredRepository.vala"
		case GGIT_STATUS_INDEX_NEW:
#line 79 "../src/Services/MonitoredRepository.vala"
		case GGIT_STATUS_INDEX_MODIFIED:
#line 79 "../src/Services/MonitoredRepository.vala"
		case GGIT_STATUS_INDEX_RENAMED:
#line 79 "../src/Services/MonitoredRepository.vala"
		case GGIT_STATUS_WORKING_TREE_MODIFIED:
#line 1827 "MonitoredRepository.c"
		{
#line 84 "../src/Services/MonitoredRepository.vala"
			result = TRUE;
#line 84 "../src/Services/MonitoredRepository.vala"
			return result;
#line 1833 "MonitoredRepository.c"
		}
		default:
		{
#line 87 "../src/Services/MonitoredRepository.vala"
			result = FALSE;
#line 87 "../src/Services/MonitoredRepository.vala"
			return result;
#line 1841 "MonitoredRepository.c"
		}
	}
}

static gboolean
__scratch_services_monitored_repository_has_uncommitted___lambda9__gee_predicate (gconstpointer g,
                                                                                  gpointer self)
{
	gboolean result;
	result = _scratch_services_monitored_repository_has_uncommitted___lambda9_ ((ScratchServicesMonitoredRepository*) self, (GgitStatusFlags*) g);
#line 78 "../src/Services/MonitoredRepository.vala"
	return result;
#line 1854 "MonitoredRepository.c"
}

gboolean
scratch_services_monitored_repository_get_has_uncommitted (ScratchServicesMonitoredRepository* self)
{
	gboolean result;
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	gboolean _tmp4_;
#line 77 "../src/Services/MonitoredRepository.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 78 "../src/Services/MonitoredRepository.vala"
	_tmp0_ = self->priv->file_status_map;
#line 78 "../src/Services/MonitoredRepository.vala"
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 78 "../src/Services/MonitoredRepository.vala"
	_tmp2_ = _tmp1_;
#line 78 "../src/Services/MonitoredRepository.vala"
	_tmp3_ = _tmp2_;
#line 78 "../src/Services/MonitoredRepository.vala"
	_tmp4_ = gee_traversable_any_match ((GeeTraversable*) _tmp3_, __scratch_services_monitored_repository_has_uncommitted___lambda9__gee_predicate, g_object_ref (self), g_object_unref);
#line 78 "../src/Services/MonitoredRepository.vala"
	_g_object_unref0 (_tmp3_);
#line 78 "../src/Services/MonitoredRepository.vala"
	result = _tmp4_;
#line 78 "../src/Services/MonitoredRepository.vala"
	return result;
#line 1884 "MonitoredRepository.c"
}

static GgitStatusFlags*
_ggit_status_flags_dup (GgitStatusFlags* self)
{
	GgitStatusFlags* dup;
#line 94 "../src/Services/MonitoredRepository.vala"
	dup = g_new0 (GgitStatusFlags, 1);
#line 94 "../src/Services/MonitoredRepository.vala"
	memcpy (dup, self, sizeof (GgitStatusFlags));
#line 94 "../src/Services/MonitoredRepository.vala"
	return dup;
#line 1897 "MonitoredRepository.c"
}

static GObject *
scratch_services_monitored_repository_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ScratchServicesMonitoredRepository * self;
	GeeHashMap* _tmp0_;
	GgitStatusOptions* _tmp1_;
#line 93 "../src/Services/MonitoredRepository.vala"
	parent_class = G_OBJECT_CLASS (scratch_services_monitored_repository_parent_class);
#line 93 "../src/Services/MonitoredRepository.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 93 "../src/Services/MonitoredRepository.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_SERVICES_TYPE_MONITORED_REPOSITORY, ScratchServicesMonitoredRepository);
#line 94 "../src/Services/MonitoredRepository.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ggit_status_flags_get_type (), (GBoxedCopyFunc) _ggit_status_flags_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 94 "../src/Services/MonitoredRepository.vala"
	_g_object_unref0 (self->priv->file_status_map);
#line 94 "../src/Services/MonitoredRepository.vala"
	self->priv->file_status_map = _tmp0_;
#line 95 "../src/Services/MonitoredRepository.vala"
	_tmp1_ = ggit_status_options_new (GGIT_STATUS_OPTION_INCLUDE_UNTRACKED | GGIT_STATUS_OPTION_RECURSE_UNTRACKED_DIRS, GGIT_STATUS_SHOW_INDEX_AND_WORKDIR, NULL);
#line 95 "../src/Services/MonitoredRepository.vala"
	__vala_GgitStatusOptions_free0 (self->priv->status_options);
#line 95 "../src/Services/MonitoredRepository.vala"
	self->priv->status_options = _tmp1_;
#line 93 "../src/Services/MonitoredRepository.vala"
	return obj;
#line 1930 "MonitoredRepository.c"
}

static void
scratch_services_monitored_repository_class_init (ScratchServicesMonitoredRepositoryClass * klass,
                                                  gpointer klass_data)
{
#line 31 "../src/Services/MonitoredRepository.vala"
	scratch_services_monitored_repository_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/Services/MonitoredRepository.vala"
	g_type_class_adjust_private_offset (klass, &ScratchServicesMonitoredRepository_private_offset);
#line 31 "../src/Services/MonitoredRepository.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_scratch_services_monitored_repository_get_property;
#line 31 "../src/Services/MonitoredRepository.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_scratch_services_monitored_repository_set_property;
#line 31 "../src/Services/MonitoredRepository.vala"
	G_OBJECT_CLASS (klass)->constructor = scratch_services_monitored_repository_constructor;
#line 31 "../src/Services/MonitoredRepository.vala"
	G_OBJECT_CLASS (klass)->finalize = scratch_services_monitored_repository_finalize;
#line 31 "../src/Services/MonitoredRepository.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_SERVICES_MONITORED_REPOSITORY_GIT_REPO_PROPERTY, scratch_services_monitored_repository_properties[SCRATCH_SERVICES_MONITORED_REPOSITORY_GIT_REPO_PROPERTY] = g_param_spec_object ("git-repo", "git-repo", "git-repo", ggit_repository_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 31 "../src/Services/MonitoredRepository.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_SERVICES_MONITORED_REPOSITORY_BRANCH_NAME_PROPERTY, scratch_services_monitored_repository_properties[SCRATCH_SERVICES_MONITORED_REPOSITORY_BRANCH_NAME_PROPERTY] = g_param_spec_string ("branch-name", "branch-name", "branch-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "../src/Services/MonitoredRepository.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_SERVICES_MONITORED_REPOSITORY_HEAD_IS_BRANCH_PROPERTY, scratch_services_monitored_repository_properties[SCRATCH_SERVICES_MONITORED_REPOSITORY_HEAD_IS_BRANCH_PROPERTY] = g_param_spec_boolean ("head-is-branch", "head-is-branch", "head-is-branch", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/Services/MonitoredRepository.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_SERVICES_MONITORED_REPOSITORY_NON_CURRENT_ENTRIES_PROPERTY, scratch_services_monitored_repository_properties[SCRATCH_SERVICES_MONITORED_REPOSITORY_NON_CURRENT_ENTRIES_PROPERTY] = g_param_spec_object ("non-current-entries", "non-current-entries", "non-current-entries", GEE_TYPE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/Services/MonitoredRepository.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_SERVICES_MONITORED_REPOSITORY_HAS_UNCOMMITTED_PROPERTY, scratch_services_monitored_repository_properties[SCRATCH_SERVICES_MONITORED_REPOSITORY_HAS_UNCOMMITTED_PROPERTY] = g_param_spec_boolean ("has-uncommitted", "has-uncommitted", "has-uncommitted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/Services/MonitoredRepository.vala"
	scratch_services_monitored_repository_signals[SCRATCH_SERVICES_MONITORED_REPOSITORY_BRANCH_CHANGED_SIGNAL] = g_signal_new ("branch-changed", SCRATCH_SERVICES_TYPE_MONITORED_REPOSITORY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 31 "../src/Services/MonitoredRepository.vala"
	scratch_services_monitored_repository_signals[SCRATCH_SERVICES_MONITORED_REPOSITORY_IGNORED_CHANGED_SIGNAL] = g_signal_new ("ignored-changed", SCRATCH_SERVICES_TYPE_MONITORED_REPOSITORY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 31 "../src/Services/MonitoredRepository.vala"
	scratch_services_monitored_repository_signals[SCRATCH_SERVICES_MONITORED_REPOSITORY_FILE_STATUS_CHANGE_SIGNAL] = g_signal_new ("file-status-change", SCRATCH_SERVICES_TYPE_MONITORED_REPOSITORY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 31 "../src/Services/MonitoredRepository.vala"
	scratch_services_monitored_repository_signals[SCRATCH_SERVICES_MONITORED_REPOSITORY_FILE_CONTENT_CHANGED_SIGNAL] = g_signal_new ("file-content-changed", SCRATCH_SERVICES_TYPE_MONITORED_REPOSITORY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1967 "MonitoredRepository.c"
}

static void
scratch_services_monitored_repository_instance_init (ScratchServicesMonitoredRepository * self,
                                                     gpointer klass)
{
	gchar* _tmp0_;
#line 31 "../src/Services/MonitoredRepository.vala"
	self->priv = scratch_services_monitored_repository_get_instance_private (self);
#line 61 "../src/Services/MonitoredRepository.vala"
	self->priv->git_monitor = NULL;
#line 62 "../src/Services/MonitoredRepository.vala"
	self->priv->gitignore_monitor = NULL;
#line 63 "../src/Services/MonitoredRepository.vala"
	_tmp0_ = g_strdup ("");
#line 63 "../src/Services/MonitoredRepository.vala"
	self->priv->_branch_name = _tmp0_;
#line 64 "../src/Services/MonitoredRepository.vala"
	self->priv->update_timer_id = (guint) 0;
#line 208 "../src/Services/MonitoredRepository.vala"
	self->priv->do_update = FALSE;
#line 267 "../src/Services/MonitoredRepository.vala"
	self->priv->refreshing = FALSE;
#line 1991 "MonitoredRepository.c"
}

static void
scratch_services_monitored_repository_finalize (GObject * obj)
{
	ScratchServicesMonitoredRepository * self;
	GFileMonitor* _tmp0_;
	GFileMonitor* _tmp2_;
#line 31 "../src/Services/MonitoredRepository.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_SERVICES_TYPE_MONITORED_REPOSITORY, ScratchServicesMonitoredRepository);
#line 133 "../src/Services/MonitoredRepository.vala"
	_tmp0_ = self->priv->git_monitor;
#line 133 "../src/Services/MonitoredRepository.vala"
	if (_tmp0_ != NULL) {
#line 2006 "MonitoredRepository.c"
		GFileMonitor* _tmp1_;
#line 134 "../src/Services/MonitoredRepository.vala"
		_tmp1_ = self->priv->git_monitor;
#line 134 "../src/Services/MonitoredRepository.vala"
		g_file_monitor_cancel (_tmp1_);
#line 2012 "MonitoredRepository.c"
	}
#line 137 "../src/Services/MonitoredRepository.vala"
	_tmp2_ = self->priv->gitignore_monitor;
#line 137 "../src/Services/MonitoredRepository.vala"
	if (_tmp2_ != NULL) {
#line 2018 "MonitoredRepository.c"
		GFileMonitor* _tmp3_;
#line 138 "../src/Services/MonitoredRepository.vala"
		_tmp3_ = self->priv->gitignore_monitor;
#line 138 "../src/Services/MonitoredRepository.vala"
		g_file_monitor_cancel (_tmp3_);
#line 2024 "MonitoredRepository.c"
	}
#line 32 "../src/Services/MonitoredRepository.vala"
	_g_object_unref0 (self->priv->_git_repo);
#line 61 "../src/Services/MonitoredRepository.vala"
	_g_object_unref0 (self->priv->git_monitor);
#line 62 "../src/Services/MonitoredRepository.vala"
	_g_object_unref0 (self->priv->gitignore_monitor);
#line 63 "../src/Services/MonitoredRepository.vala"
	_g_free0 (self->priv->_branch_name);
#line 65 "../src/Services/MonitoredRepository.vala"
	__vala_GgitStatusOptions_free0 (self->priv->status_options);
#line 68 "../src/Services/MonitoredRepository.vala"
	_g_object_unref0 (self->priv->file_status_map);
#line 31 "../src/Services/MonitoredRepository.vala"
	G_OBJECT_CLASS (scratch_services_monitored_repository_parent_class)->finalize (obj);
#line 2040 "MonitoredRepository.c"
}

static GType
scratch_services_monitored_repository_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScratchServicesMonitoredRepositoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scratch_services_monitored_repository_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScratchServicesMonitoredRepository), 0, (GInstanceInitFunc) scratch_services_monitored_repository_instance_init, NULL };
	GType scratch_services_monitored_repository_type_id;
	scratch_services_monitored_repository_type_id = g_type_register_static (G_TYPE_OBJECT, "ScratchServicesMonitoredRepository", &g_define_type_info, 0);
	ScratchServicesMonitoredRepository_private_offset = g_type_add_instance_private (scratch_services_monitored_repository_type_id, sizeof (ScratchServicesMonitoredRepositoryPrivate));
	return scratch_services_monitored_repository_type_id;
}

GType
scratch_services_monitored_repository_get_type (void)
{
	static volatile gsize scratch_services_monitored_repository_type_id__once = 0;
	if (g_once_init_enter (&scratch_services_monitored_repository_type_id__once)) {
		GType scratch_services_monitored_repository_type_id;
		scratch_services_monitored_repository_type_id = scratch_services_monitored_repository_get_type_once ();
		g_once_init_leave (&scratch_services_monitored_repository_type_id__once, scratch_services_monitored_repository_type_id);
	}
	return scratch_services_monitored_repository_type_id__once;
}

static void
_vala_scratch_services_monitored_repository_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec)
{
	ScratchServicesMonitoredRepository * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_SERVICES_TYPE_MONITORED_REPOSITORY, ScratchServicesMonitoredRepository);
#line 31 "../src/Services/MonitoredRepository.vala"
	switch (property_id) {
#line 31 "../src/Services/MonitoredRepository.vala"
		case SCRATCH_SERVICES_MONITORED_REPOSITORY_GIT_REPO_PROPERTY:
#line 31 "../src/Services/MonitoredRepository.vala"
		g_value_set_object (value, scratch_services_monitored_repository_get_git_repo (self));
#line 31 "../src/Services/MonitoredRepository.vala"
		break;
#line 31 "../src/Services/MonitoredRepository.vala"
		case SCRATCH_SERVICES_MONITORED_REPOSITORY_BRANCH_NAME_PROPERTY:
#line 31 "../src/Services/MonitoredRepository.vala"
		g_value_set_string (value, scratch_services_monitored_repository_get_branch_name (self));
#line 31 "../src/Services/MonitoredRepository.vala"
		break;
#line 31 "../src/Services/MonitoredRepository.vala"
		case SCRATCH_SERVICES_MONITORED_REPOSITORY_HEAD_IS_BRANCH_PROPERTY:
#line 31 "../src/Services/MonitoredRepository.vala"
		g_value_set_boolean (value, scratch_services_monitored_repository_get_head_is_branch (self));
#line 31 "../src/Services/MonitoredRepository.vala"
		break;
#line 31 "../src/Services/MonitoredRepository.vala"
		case SCRATCH_SERVICES_MONITORED_REPOSITORY_NON_CURRENT_ENTRIES_PROPERTY:
#line 31 "../src/Services/MonitoredRepository.vala"
		g_value_take_object (value, scratch_services_monitored_repository_get_non_current_entries (self));
#line 31 "../src/Services/MonitoredRepository.vala"
		break;
#line 31 "../src/Services/MonitoredRepository.vala"
		case SCRATCH_SERVICES_MONITORED_REPOSITORY_HAS_UNCOMMITTED_PROPERTY:
#line 31 "../src/Services/MonitoredRepository.vala"
		g_value_set_boolean (value, scratch_services_monitored_repository_get_has_uncommitted (self));
#line 31 "../src/Services/MonitoredRepository.vala"
		break;
#line 2105 "MonitoredRepository.c"
		default:
#line 31 "../src/Services/MonitoredRepository.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/Services/MonitoredRepository.vala"
		break;
#line 2111 "MonitoredRepository.c"
	}
}

static void
_vala_scratch_services_monitored_repository_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec)
{
	ScratchServicesMonitoredRepository * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_SERVICES_TYPE_MONITORED_REPOSITORY, ScratchServicesMonitoredRepository);
#line 31 "../src/Services/MonitoredRepository.vala"
	switch (property_id) {
#line 31 "../src/Services/MonitoredRepository.vala"
		case SCRATCH_SERVICES_MONITORED_REPOSITORY_GIT_REPO_PROPERTY:
#line 31 "../src/Services/MonitoredRepository.vala"
		scratch_services_monitored_repository_set_git_repo (self, g_value_get_object (value));
#line 31 "../src/Services/MonitoredRepository.vala"
		break;
#line 31 "../src/Services/MonitoredRepository.vala"
		case SCRATCH_SERVICES_MONITORED_REPOSITORY_BRANCH_NAME_PROPERTY:
#line 31 "../src/Services/MonitoredRepository.vala"
		scratch_services_monitored_repository_set_branch_name (self, g_value_get_string (value));
#line 31 "../src/Services/MonitoredRepository.vala"
		break;
#line 2137 "MonitoredRepository.c"
		default:
#line 31 "../src/Services/MonitoredRepository.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/Services/MonitoredRepository.vala"
		break;
#line 2143 "MonitoredRepository.c"
	}
}

